MODULE colorhelix_module
  USE color_functions_extended!external
  USE color_functions_ciecam02
  USE palette_modules
  INTEGER :: flgmodel,flgrgblike,flgmaxsat,flgsatnoclip,flgsatmonotonic,flg_inichroma=0,itermode
  INTEGER :: qmode=0,flg_maxrgb,flg_excludeeps,flg_scalceiling,flg_insect,flg_discrete,flggamp,flgx01
  INTEGER :: flg_rangemaxsat,lmin_maxsat,lmax_maxsat,nlo4info(0:3),nhi4info(0:3),nlosave(0:3),nhisave(0:3)
  INTEGER :: flgsplit=0,mirrormode=1,invertmode=0,rgbperm=123,flgdouble,nlevuse,nlevnoeps,ifnrgb(1:3)
  INTEGER :: flggrayrange=0,rainbowsel=0,rbbrightsel=0,flguserrange=0,wbmode=2,flgrots2
  INTEGER,PARAMETER :: nlambda=300
  REAL(KIND=8),DIMENSION(0:3,0:nlambda) :: rainbowdata
  REAL(KIND=8) :: scal_jcheuc=1.2608d0, scal_jch=1.d0
  REAL(KIND=8) :: xmin_maxsat,xmax_maxsat,minslope_thres,kpart,xpartition,xmargin_noclip,phi_double,sgnphi,xscal0,xscal1
  REAL(KIND=8) :: start_color,rotations,rots2,start_rgb,start_lab,rot_rgb,rot_lab,rot_off=1.d0
  REAL(KIND=8) :: sathue_inp,sathue,maxsat,maxxsat=16.d0,x_ini=1.d-6,sw_scurve,pwr_scurve,sw_srot,pwr_srot
  REAL(KIND=8),DIMENSION(3) :: urgb_ini,xyz_ini
  REAL(KIND=8) :: gamma,gamma_rot,gamma_amp,pwr_gamma,pwr_gamma_rot,pwr_gamma_amp,power_amp
  REAL(KIND=8),DIMENSION(1:3) :: u,v,w,rgbeps,rgbflat,rgbflat1
  REAL(KIND=8),DIMENSION(:),ALLOCATABLE :: afullsat
  REAL(KIND=8) :: rgb_gamma,grayrange(0:1)
  REAL(KIND=8) :: kellipse,alpha,alpha_deg
  REAL(KIND=8) :: userpalrange(0:1)
  REAL(KIND=8) :: grayflat,blackeps,colortemp=6500.d0,greencorr=1.d0,cctexp,cctexp2,whtexp
  INTEGER :: flg2white
! Whitebalance
  INTEGER,PARAMETER :: nmaxcct=10000
  INTEGER :: ncct,nheader
  REAL(KIND=8) :: cctmin=1000.d0,cctmax=25100.d0
  REAL(KIND=8),DIMENSION(0:3,0:nmaxcct) :: cctramp
  REAL(KIND=8),DIMENSION(1:3) :: whitergb,whitergb2,whiteinp,whiteinp2
  REAL(KIND=8),DIMENSION(1:3,1:3) :: mat_ipt4corr=reshape((/ 0.999987871163d0,-0.000000000137d0, 0.000162680292d0,&
                                                                -0.000000000137d0, 0.999987884394d0, 0.000001690207d0,&
                                                                -0.000162680292d0,-0.000001690207d0, 0.999987871162d0/),(/3,3/))
  
  REAL(KIND=8),DIMENSION(1:3,1:3) :: mat_ipt5corr=reshape((/ 0.999987873529d0, 0.000000007306d0, 0.000235455331d0,&
                                                                 0.000000007306d0, 0.999987899323d0,-0.000062059096d0,&
                                                                -0.000235455331d0, 0.000062059096d0, 0.999987871603d0/),(/3,3/))
  LOGICAL :: did_ini_cctramp=.FALSE.,is_mired=.FALSE.,wrgb1forcewhite=.false.,wrgb2forcewhite=.false.
!
!  REAL(KIND=8),DIMENSION(3,0:3) :: rgb_primaries!xyz for white, red, green, blue
  REAL(KIND=8),DIMENSION(3) :: red_prim,grn_prim,blu_prim,wht_prim
  CHARACTER(LEN=20) :: name_rgb
  CHARACTER(LEN=40) :: file_cct,palettefile
  LOGICAL :: firstmake=.TRUE.,doalloc_fullsat=.TRUE.,usesattable=.FALSE.,did_ini_ciecam02=.FALSE.,&
       do_grayflat=.FALSE.,do_blackeps=.FALSE.,did_ini_rainbow=.FALSE.
  CHARACTER(LEN=1) :: firstchar_nextline
  LOGICAL :: eof_nextline=.false.
  
  CONTAINS

  SUBROUTINE colorhelix_inpar(ufile)
    IMPLICIT NONE
    INTEGER :: ufile,pfile,qfile,ntot,i,j,ifav,preset_helix,preset_mode,idum
    REAL(KIND=8) :: favpar(12),rdum
    CHARACTER (LEN=1) :: firstchar
    CHARACTER (LEN=64) :: inpfile
    LOGICAL :: foundfav=.FALSE.
    CALL get_command_argument(1, inpfile)
    IF (LEN_TRIM(inpfile)==0) inpfile='colorhelix.inp'
    OPEN(ufile,FILE=trim(inpfile))
    print '(3a)','inpfile = "',inpfile,'"'
!   Number of levels (<=0 for default=256), model
    READ(ufile,*) !dummy line
    READ(ufile,*) ntot,levelorder,flg_discrete
    READ(ufile,*) flgmodel,flgrgblike,flggamp
!   Start color ([1:3] = RGB, mod 3 used for outside)    
    READ(ufile,*) start_color,preset_helix,preset_mode
!   Rotations
    READ(ufile,*) rotations,sw_scurve,pwr_scurve
!   Saturation and gamma correction
    READ(ufile,*) sathue_inp,flgmaxsat,minslope_thres!,itermode
!   maxsat determination range min,max,flag
    READ(ufile,*) xmin_maxsat,xmax_maxsat,flg_rangemaxsat
    READ(ufile,*) gamma,gamma_rot,gamma_amp
    READ(ufile,*) power_amp,sw_srot,pwr_srot
    READ(ufile,*) grayrange(0:1),flggrayrange
    READ(ufile,*) ifnrgb(1:3)
    READ(ufile,*) palettefile,nheader
    READ(ufile,*) userpalrange(0:1),flguserrange
    READ(ufile,*) !dummy line
    READ(ufile,*) flgsplit,mirrormode,invertmode
    READ(ufile,*) rgbperm
    READ(ufile,*) flgdouble,kpart,xmargin_noclip
    READ(ufile,*) rots2,flgrots2
    READ(ufile,*) kellipse,alpha_deg,flg_insect
    READ(ufile,*) grayflat,blackeps
    READ(ufile,*) rgbflat1
    READ(ufile,*) rgbeps
    READ(ufile,*) colortemp,flg_excludeeps,flg_scalceiling
    READ(ufile,*) greencorr,flgx01
    READ(ufile,*) cctexp,cctexp2,whtexp
    READ(ufile,*) whitergb
    READ(ufile,*) whitergb2
    READ(ufile,*) file_cct
    READ(ufile,*) !dummy line
!   RGB-to-gray weighs (<=0 for default), CCT fot whitepoint
    READ(ufile,*) wr,wg,wb
    READ(ufile,*) selrgb,selwluma,flg_maxrgb
    !rgb-primaries
    READ(ufile,*) red_prim(1:2)
    READ(ufile,*) grn_prim(1:2)
    READ(ufile,*) blu_prim(1:2)
    READ(ufile,*) wht_prim(1:2),rgb_gamma
    CLOSE(ufile)
    red_prim(3)=1.d0-red_prim(1)-red_prim(2)
    grn_prim(3)=1.d0-grn_prim(1)-grn_prim(2)
    blu_prim(3)=1.d0-blu_prim(1)-blu_prim(2)
    wht_prim(3)=1.d0-wht_prim(1)-wht_prim(2)
    XYZwhite(:)=wht_prim(:)/wht_prim(2)!scale to Y=1
    name_rgb='sRGB (user-def)'
!**** Read preset
    IF (preset_helix>=0) THEN
       OPEN(pfile,FILE='colorhelix-favorites.txt')
       DO i=1,1000
          READ(pfile,*) firstchar
          IF (firstchar=='>') EXIT
       ENDDO
       READ(pfile,*)
       DO i=0,1000!(a maximum of 1000 schemes should be vastly enough ;-)
          READ(pfile,*,end=19,err=19) ifav,favpar(1:11)
          foundfav=ifav==preset_helix
          IF (foundfav) EXIT
       ENDDO
  19   CLOSE(pfile)
       IF (foundfav) THEN
          WRITE(*,'(A,I3,A)') '*** Using favorite helix params preset',ifav,'***'
          flgrgblike=1
          if (preset_mode>=0) then
             start_color=favpar(1)
             rotations=favpar(2)
          endif
          if (preset_mode>=1) then
             sathue_inp=favpar(3)
             flgmodel=int(favpar(4))
             flgrgblike=int(favpar(5))
          endif
          if (preset_mode>=2) then
             gamma=favpar(6)
             gamma_rot=favpar(7)
             power_amp=favpar(8)
          endif
          if (preset_mode>=3) then
             flgsplit=favpar(9)
             mirrormode=favpar(10)
             invertmode=favpar(11)
          endif
       ELSE
          WRITE(*,'(A,I3)') 'No favorite found, using default param file.'
       ENDIF
    ELSE
       WRITE(*,'(A,I3)') '*** Using default param file ***'
    ENDIF
    IF (levelorder<0) THEN
       sgnorder=-1
    ELSE
       sgnorder=1
    ENDIF
    sathue=sathue_inp
    alpha=alpha_deg*d2r
    pfile=ufile+1
    qfile=ufile+2
    flgsatmonotonic=flgmaxsat/10
    flgsatnoclip=flgmaxsat-10*flgsatmonotonic
    skip_checkceiling=flgmaxsat<=-100.or.flgmodel>=100
    if (flgmodel>=100) then
       flgsatmonotonic=0
       flgsatnoclip=0
    else if (flgdouble/=0) then
       flgsatmonotonic=0
       !flgsatnoclip=0!remove later
    endif
    if (flgdouble>3.or.flgdouble<0) then
       phi_double=dble(flgdouble)/360
       sgnphi=sign(1,flgdouble)
    endif
    if (kpart>1.d0) then
       xpartition=1.d0/kpart
    else
       xpartition=kpart
    endif
    xscal0=1.d0/xpartition
    xscal1=1.d0/(1.d0-xpartition)
    do_grayflat=grayflat>0.d0
    do_blackeps=blackeps>0.d0.and.do_grayflat.and.flgsplit<0!exclude split+mirror+invert modes from blackeps
    IF (maxval(rgbflat1)>0.d0) THEN
       rgbflat(:)=rgbflat1(:)/maxval(rgbflat1)*grayflat
    ELSE
       rgbflat(:)=grayflat
    ENDIF
!    IF (minslope_thres<-1.d0.OR.minslope_thres>=1.d0) THEN
!       PRINT *,'minslope_thres must be >=0 and <1'
!       minslope_thres=max(min(minslope_thres,1.d0),0.d0)
!    ENDIF
    IF (flgsatnoclip==4) THEN
! slightly non-elegant but easy way to dump itermode into flgmaxsat
       itermode=1
    ELSE
       itermode=0
    ENDIF
    IF (itermode>=1) THEN
       flgsatmonotonic=0
       flg_rangemaxsat=0
    ENDIF
    IF (flgmodel<0) THEN
       flgsatmonotonic=0
       flg_rangemaxsat=0
       flgsatnoclip=0
    ENDIF
    IF (flg_rangemaxsat<=0.OR.xmax_maxsat<=xmin_maxsat) THEN
       xmin_maxsat=0.d0
       xmax_maxsat=1.d0
    ENDIF
    WRITE(*,*) 'flgmaxsat,flgsatnoclip,flgsatmonotonic =',flgmaxsat,flgsatnoclip,flgsatmonotonic
    WRITE(*,*) 'flg_rangemaxsat =',flg_rangemaxsat
    pwr_gamma=1.d0/gamma
    pwr_gamma_rot=1.d0/gamma_rot
    pwr_gamma_amp=1.d0/gamma_amp
    WRITE(*,*)
    IF (selwluma<0) THEN
       wr=1.d0/3.d0
       wg=wr
       wb=wr
       WRITE(*,*) 'Equal luma weights'
    ELSE IF (selwluma>=1.AND.selwluma<=6) THEN
       wr=all_wluma(1,selwluma)
       wg=all_wluma(2,selwluma)
       wb=all_wluma(3,selwluma)
       WRITE(*,'(A,3(1X,F8.6))') 'Preset luma weights:',wr,wg,wb
    ELSE
       WRITE(*,'(A,3(1X,F8.6))') 'User-defined luma weights:',wr,wg,wb
    ENDIF
    WRITE(*,*)
!**** Calculate RGB/Lab-equivalents to start_color and rotations (for info only)
    rot_off=-0.75d0
    IF ((flgmodel>=1.AND.flgrgblike<=0).OR.(flgmodel<1.AND.flgrgblike<0)) THEN!input=L*a*b*
!phi_start=0.25d0-start_color/3.d0! mimic rgb in lab
!phi_start=(1.d0-start_color)/4.d0! mimic lab in rgb
       write(*,*) '******** Input conversion: Lab -> RGB'
       start_rgb=0.75d0*(start_color-rot_off)
       start_lab=start_color
       rot_rgb=rotations
       rot_lab=rotations
    ELSE!input=RGB
       write(*,*) '******** Input conversion: RGB -> Lab'
       start_rgb=start_color
       start_lab=4.d0/3.d0*start_color+rot_off
       rot_rgb=rotations
       rot_lab=rotations
    ENDIF
    IF (flgx01>=1) THEN
       IF (minval(whitergb)<0.d0) THEN
          whitergb=(/1.d0,1.d0,1.d0/)
          wrgb1forcewhite=.true.
       ENDIF
       IF (minval(whitergb2)<0.d0) THEN
          whitergb2=(/1.d0,1.d0,1.d0/)
          wrgb2forcewhite=.true.
       ENDIF
       rdum=max(maxval(whitergb),1.d0)
       whitergb(:)=whitergb(:)/rdum
       rdum=max(maxval(whitergb2),1.d0)
       whitergb2(:)=whitergb2(:)/rdum
    ELSE IF (flgx01<=-1) THEN
       whitergb=(/1.d0,1.d0,1.d0/)
       wrgb1forcewhite=.true.
       whitergb2=(/1.d0,1.d0,1.d0/)
       wrgb2forcewhite=.true.
    ENDIF
    IF (start_rgb<0.d0) start_rgb=start_rgb+3.d0
    IF (start_lab<0.d0) start_lab=start_lab+4.d0
    IF (start_rgb>=3.d0) start_rgb=start_rgb-3.d0
    IF (start_lab>=4.d0) start_lab=start_lab-4.d0
    WRITE(*,'(A,2(1X,F8.4))') 'Start colour RGB, L*a*b* =',start_rgb,start_lab
    WRITE(*,'(A,2(1X,F8.4))') 'Rotations                =',rot_rgb,rot_lab
!(1.d0-start_color)
!  -- Sanity check
    IF (ntot<2.OR.ntot>nlevels_max+1) THEN
       IF (ntot<2)   WRITE(*,*) 'Minimum ntot=2 color levels required.'
       IF (ntot>nlevels_max+1) WRITE(*,*) 'Maximum ntot =',nlevels_max+1,', color levels allowed.'
       WRITE(*,*) 'Using default (256 levels).'
       ntot=256
       flg_discrete=0
    ENDIF
    IF (flg_discrete>=2) THEN
       ntot=ntot+1!address fence-post problem
    ENDIF
    IF (flgsplit==1) THEN
       nlevels=2*ntot-2
    ELSE IF (flgsplit>=2) THEN
       nlevels=2*ntot-1
    ELSE
       nlevels=ntot-1
    ENDIF
    nlevnoeps=nlevels
    IF (do_blackeps) THEN
       nlevels=nlevels+2
    ENDIF
    nlevuse=ntot-1
    lmin_maxsat=nint(xmin_maxsat*nlevuse)
    lmax_maxsat=nint(xmax_maxsat*nlevuse)
    write(*,*) 'lmin,lmax maxsat =',lmin_maxsat,lmax_maxsat
    CALL palette_initialize
!**** RGB primaries
    IF (selrgb>12) THEN
       red_prim=srgb_red
       grn_prim=srgb_grn
       blu_prim=srgb_blu
       wht_prim=srgb_wht
       XYZwhite=whitepoint_d65
       rgb_gamma=0.d0!force use of srgb_gamma
       name_rgb='sRGB (default)'
    ELSE IF (selrgb>=0) THEN
       OPEN(qfile,FILE='rgb-primaries.asc')
       DO i=-2,selrgb-1
          READ(qfile,*)
       ENDDO
       READ(qfile,*) idum,(red_prim(j),j=1,2),(grn_prim(j),j=1,2),(blu_prim(j),j=1,2), &
            (wht_prim(j),j=1,2),rgb_gamma,name_rgb
       red_prim(3)=1.d0-red_prim(1)-red_prim(2)
       grn_prim(3)=1.d0-grn_prim(1)-grn_prim(2)
       blu_prim(3)=1.d0-blu_prim(1)-blu_prim(2)
       wht_prim(3)=1.d0-wht_prim(1)-wht_prim(2)
       XYZwhite(:)=wht_prim(:)/wht_prim(2)!scale to Y=1
       CLOSE(qfile)
!.... else keep user-defined values
    ENDIF
    RETURN
  END SUBROUTINE colorhelix_inpar
  
  SUBROUTINE colorhelix_outdat
    IMPLICIT NONE
    INTEGER :: i,j
    REAL(KIND=8) :: x,x1,x2,x3,x4,rgb(3),rgb01(3),drgb(3),xyz(3),xyY(3),sumxyz,phi
    OPEN(33,FILE='colorhelix-rgbdat.aux')
    OPEN(43,FILE='colorhelix-gp.aux')
    WRITE(33,'()')
    WRITE(33,'(3(2X,F14.8),10X,"Red primary xyz")') (red_prim(i),i=1,3)
    WRITE(33,'(3(2X,F14.8),10X,"Green prim. xyz")') (grn_prim(i),i=1,3)
    WRITE(33,'(3(2X,F14.8),10X,"Blue prim.  xyz")') (blu_prim(i),i=1,3)
    WRITE(33,'(3(2X,F14.8),10X,"White point xyz")') (XYZwhite(i)/sum(XYZwhite),i=1,3)
    WRITE(33,'(3(2X,F14.8),10X,"White point XYZ")') (XYZwhite(i),i=1,3)
    WRITE(33,'(2X,F14.8,42X,"Gamma")') rgb_gamma
    WRITE(33,'(3(2X,F14.8),10X,"Initial RGB")')     (urgb_ini(i),i=1,3)
    WRITE(33,'(3(2X,F14.8),10X,"Initial xyz")')     (xyz_ini(i),i=1,3)
    CLOSE(33)
    WRITE(43,'(A,I4,2(A,I2))') 'ntot=',nlevels+1,'; levelorder=',levelorder,'; flg_discrete=',flg_discrete
    WRITE(43,'(3(A,I3))') 'flgmodel=',flgmodel,'; flgrgblike=',flgrgblike,'; flggamp=',flggamp
    WRITE(43,'(A,F9.4)') 'start=',start_color
    WRITE(43,'(3(A,F9.4))') 'rots=',rotations
    WRITE(43,'(3(A,F9.4))') 'sathue_inp=',sathue_inp
    WRITE(43,'(3(A,F9.4))') 'gamma_gry=',gamma,'; gamma_rot=',gamma_rot,'; gamma_amp=',gamma_amp
    WRITE(43,'(3(A,F9.4))') 'power_amp=',power_amp,'; sw_srot=',sw_srot,'; pwr_srot=',pwr_srot
    WRITE(43,'(2(A,F9.6),A,I2)') 'grayrange0=',grayrange(0),'; grayrange1=',grayrange(1),'; flggrayrange=',flggrayrange
    WRITE(43,'(3(A,I3))') 'ifnrgb1=',ifnrgb(1),'; ifnrgb2=',ifnrgb(2),'; ifnrgb3=',ifnrgb(3)
    WRITE(43,'(3(A),I4)') 'palettefile="',trim(palettefile),'"; nheader=',nheader
    WRITE(43,'(3(A,F9.6))') 'wr=',wr,'; wg=',wg,'; wb=',wb
    WRITE(43,'(2(A,I2))') 'selrgb=',selrgb,'; selwluma=',selwluma,'; flg_maxrgb=',flg_maxrgb
    WRITE(43,'(3(A,I2))') 'flgsplit=',flgsplit,'; mirrormode=',mirrormode,'; invertmode=',invertmode
    WRITE(43,'(A,I3)') 'rgbperm=',rgbperm
    WRITE(43,'(A,I4,2(A,F9.6))') 'flgdouble=',flgdouble,'; kpart=',kpart,'; xmargin_noclip=',xmargin_noclip
    WRITE(43,'(A,F9.6,A,I3)') 'rots2=',rots2,'; flgrots2=',flgrots2
    WRITE(43,'(A,F16.12,A,F9.4,A,I2)') 'kellipse=',kellipse,'; alphadeg=',alpha_deg,'; flg_insect=',flg_insect
    WRITE(43,'(2(A,F9.6))') 'grayflat=',grayflat,'; blackeps=',blackeps
    WRITE(43,'(3(A,F9.6))') 'rflat=',rgbflat(1),'; gflat=',rgbflat(2),'; bflat=',rgbflat(3)
    WRITE(43,'(3(A,F9.6))') 'reps=',rgbeps(1),'; geps=',rgbeps(2),'; beps=',rgbeps(3)
    WRITE(43,'(A,1PE16.8,0P,2(A,I2))') 'colortemp=',colortemp,&
         '; flg_excludeeps=',flg_excludeeps,'; flg_scalceiling=',flg_scalceiling
    WRITE(43,'(A,F9.6,A,I2)') 'greencorr=',greencorr,'; flgx01=',flgx01
    WRITE(43,'(3(A,F9.6))') 'cctexp=',cctexp,'; cctexp2=',cctexp2,'; whtexp=',whtexp
    WRITE(43,'(3(A,F9.6))') 'rwhite=',whitergb(1),'; gwhite=',whitergb(2),'; bwhite=',whitergb(3)
    WRITE(43,'(3(A,F9.6))') 'rwhite2=',whitergb2(1),'; gwhite2=',whitergb2(2),'; bwhite2=',whitergb2(3)
    WRITE(43,'(3A)') 'file_cct="',trim(file_cct),'"'
    WRITE(43,*) '####'
    WRITE(43,'(A)') 'qexp=1./gamma_gry'
!    READ(ufile,*) flgsplit,mirrormode,invertmode
!    READ(ufile,*) rgbperm
!    READ(ufile,*) grayflat,blackeps
!    CALL colorhelix_header(43,1)
    CLOSE(43)
    OPEN(22,FILE='colorhelix.out')
    OPEN(32,FILE='colorhelix.rgb')
    IF (flgmodel>=1.and.flgmodel<100) THEN
       OPEN(34,FILE='colorhelix.xyz')
       OPEN(35,FILE='colorhelix.xyy')
       OPEN(36,FILE='colorhelix.lab')
       OPEN(38,FILE='colorhelix.lch')
    ENDIF
    WRITE(22,2201) '#Level','R','G','B','Gray','xGray','R01','G01','B01','slope','x'
    CALL colorhelix_header(32,0)! RGB output header
    IF (flgmodel>=1.and.flgmodel<100) THEN
       CALL colorhelix_header(34,0)! XYZ output header
       CALL colorhelix_header(35,0)! xyY output header
       CALL colorhelix_header(36,0)! Lab output header
       CALL colorhelix_header(38,0)! Lab output header
    ENDIF
!   Check palette sanity and repair if necessary
    CALL palette_sanity
!   Output palette files
    x2=0.d0
    DO i=0,nlevels
       IF (flags_palette(i)<0) THEN
          PRINT *,'Skipping invalid palette entry'
!          CYCLE
       ENDIF
       IF (do_blackeps) THEN
          IF (i<2) THEN
             x=-blackeps
             x1=x
             x2=x
             x3=x
             x4=x
          ELSE
             x=dble(i-2)/dble(nlevels-2)
             x3=dble(i-1)/dble(nlevels-2)
             x4=dble(i-3)/dble(nlevels-2)
             x1=dble(i-2)/dble(nlevels-1)
             x2=dble(i-1)/dble(nlevels-1)
          ENDIF
       ELSE
          x=dble(i)/dble(nlevels)
          x3=dble(i+1)/dble(nlevels)
          x4=dble(i-1)/dble(nlevels)
          x1=dble(i)/dble(nlevels+1)
          x2=dble(i+1)/dble(nlevels+1)
       ENDIF
       rgb=(/red(i),grn(i),blu(i)/)
       drgb(1)=red(i)-gry(i)
       drgb(2)=grn(i)-gry(i)
       drgb(3)=blu(i)-gry(i)
       CALL mapto01(drgb,rgb01,31,(/0.d0,1.d0/))!to get the rgb 'polar angle'
!                     1 2      3      4      5      6       7-9  10           11
       WRITE(22,2200) i,red(i),grn(i),blu(i),gry(i),xgry(i),drgb,slope_gry(i),dble(i)/nlevuse
       IF (flg_discrete==1) THEN
          WRITE(32,3200) x1,red(i),grn(i),blu(i)
          WRITE(32,3200) x2,red(i),grn(i),blu(i)
       ELSE IF (flg_discrete==2.and.i.lt.nlevnoeps) THEN
          WRITE(32,3200) x,red(i),grn(i),blu(i)
          WRITE(32,3200) x3,red(i),grn(i),blu(i)
       ELSE IF (flg_discrete==3.and.i>=1.and.i.le.nlevnoeps) THEN
          WRITE(32,3200) x4,red(i),grn(i),blu(i)
          WRITE(32,3200) x,red(i),grn(i),blu(i)
       ELSE IF (flg_discrete==4.and.i.lt.nlevnoeps) THEN
          WRITE(32,3200) x,(red(i)+red(i+1))/2.d0,(grn(i)+grn(i+1))/2.d0,(blu(i)+blu(i+1))/2.d0
          WRITE(32,3200) x3,(red(i)+red(i+1))/2.d0,(grn(i)+grn(i+1))/2.d0,(blu(i)+blu(i+1))/2.d0
       ELSE
          WRITE(32,3200) x,red(i),grn(i),blu(i)
       ENDIF
       IF (flgmodel>=1.and.flgmodel<100) THEN
          xyz(:)=CIEXYZ(:,i)
          sumxyz=sum(xyz)
          IF (sumxyz<=0.d0.OR.sum(xyz)/=sum(xyz)) THEN!zero and NaN handling
             xyY(1:2)=xyz_ini(1:2);xyY(3)=0.d0
!             WRITE(*,'(A,4(1X,F9.6))') 'sum<=0; xyY =',xyY
          ELSE
             xyY(1)=xyz(1)/sumxyz;xyY(2)=xyz(2)/sumxyz;xyY(3)=xyz(2)
!             WRITE(*,'(A,4(1X,F9.6))') 'sum>0;  xyY =',xyY
          ENDIF
!          WRITE(*,'(A,4(1X,F9.6))') '      ; xyz_ini =',xyz_ini
!          WRITE(*,*) 'xyz(2),xyz(2)==xyz(2) =',xyz(2),xyz(2)==xyz(2)
!          stop
          WRITE(34,3400) x,(1.d2*CIEXYZ(j,i),j=1,3)
          WRITE(35,3400) x,(xyY(j),j=1,2),1.d2*xyY(3)
          WRITE(36,3400) x,(CIELAB(j,i),j=1,3)
          WRITE(38,3400) x,(CIELCH(j,i),j=1,3)
       ENDIF
       x2=x
    ENDDO
    CLOSE(22)
    CLOSE(32)
    IF (flgmodel>=1.and.flgmodel<100) CLOSE(34)
    IF (flgmodel>=1.and.flgmodel<100) CLOSE(35)
    IF (flgmodel>=1.and.flgmodel<100) CLOSE(36)
    IF (flgmodel>=1.and.flgmodel<100) CLOSE(38)
  2200 FORMAT(I6,2X,5(2X,F12.6),2X,3(2X,F12.6),2X,F12.6,2X,F8.6)
  2201 FORMAT(A6,2X,5(2X,A12),  2X,3(2X,A12),  2X,A12,  2X,A8)
  3200 FORMAT(F9.6,2X,3(2X,F12.6))
  3400 FORMAT(F9.6,2X,3(2X,F12.4))
  3201 FORMAT(A9,2X,3(2X,A12))
    RETURN
  END SUBROUTINE colorhelix_outdat
  
  SUBROUTINE colorhelix_header(ufile,mode)
    IMPLICIT NONE
    INTEGER :: ufile,mode
    CHARACTER (LEN=1) :: xcomment='#'
    IF (mode==1) THEN
       xcomment=' '
    ELSE
       xcomment='#'
    ENDIF
    WRITE(ufile,'(A,A,I4,2(A,I2))') xcomment,'ntot=',nlevels+1,'; levelorder=',levelorder,'; flg_discrete=',flg_discrete
    WRITE(ufile,'(A,3(A,I3))') xcomment,'flgmodel=',flgmodel,'; flgrgblike=',flgrgblike,'; flggamp=',flggamp
    WRITE(ufile,'(A,A,F9.4)')    xcomment,'start=',start_color
    WRITE(ufile,'(A,3(A,F9.4))') xcomment,'rots=',rotations,'; sw_s=',sw_scurve,'; pwr_s=',pwr_scurve
    WRITE(ufile,'(A,A,F9.4,A,I2,A,F8.6,A,I2)') xcomment,'sathue_inp=',sathue_inp,'; flgmaxsat=',flgmaxsat,&
         '; minslope_thres=', minslope_thres,'; itermode =',itermode!minslope_thres
    WRITE(ufile,'(A,2(A,F9.4),A,I2)') xcomment,'xmin_xsat=',xmin_maxsat,'; xmax_xsat=', xmax_maxsat,'; flg_range=',flg_rangemaxsat
    WRITE(ufile,'(A,3(A,F9.4))') xcomment,'gamma_gry=',gamma,'; gamma_rot=',gamma_rot,'; gamma_amp=',gamma_amp
    WRITE(ufile,'(A,3(A,F9.4))') xcomment,'power_amp=',power_amp,'; sw_srot=',sw_srot,'; pwr_srot=',pwr_srot
    WRITE(ufile,'(A,2(A,F9.6),A,I2)') xcomment,'grayrange0=',grayrange(0),'; grayrange1=',grayrange(1),&
         '; flggrayrange=',flggrayrange
    WRITE(ufile,'(A,3(A,I3))') xcomment,'ifnrgb1=',ifnrgb(1),'; ifnrgb2=',ifnrgb(2),'; ifnrgb3=',ifnrgb(3)
    WRITE(ufile,'(4(A),I4)') xcomment,'palettefile="',trim(palettefile),'"; nheader=',nheader
    WRITE(ufile,'(A,3(A,F9.6))') xcomment,'wr=',wr,'; wg=',wg,'; wb=',wb
    WRITE(ufile,'(A,3(A,I2))') xcomment,'selrgb=',selrgb,'; selwluma=',selwluma,'; flg_maxrgb=',flg_maxrgb
    WRITE(ufile,'(A,3(A,I2))') xcomment,'flgsplit=',flgsplit,'; mirrormode=',mirrormode,'; invertmode=',invertmode
    WRITE(ufile,'(A,A,I3.3)') xcomment,'rgbperm=',rgbperm
    WRITE(ufile,'(A,A,I4,2(A,F9.6))') xcomment,'flgdouble=',flgdouble,'; kpart=',kpart,'; xmargin_noclip=',xmargin_noclip
    WRITE(ufile,'(A,A,F9.6,A,I3)') xcomment,'rots2=',rots2,'; flgrots2=',flgrots2
    WRITE(ufile,'(2A,F16.12,A,F9.4,A,I2)') xcomment,'kellipse=',kellipse,'; alphadeg=',alpha_deg,'; flg_insect=',flg_insect
    WRITE(ufile,'(A,2(A,F9.6))') xcomment,'grayflat=',grayflat,'; blackeps=',blackeps
    WRITE(ufile,'(A,3(A,F9.6))') xcomment,'rgbflat=',rgbflat(1),', ',rgbflat(2),', ',rgbflat(3)
    WRITE(ufile,'(A,3(A,F9.6))') xcomment,'rgbeps=',rgbeps(1),', ',rgbeps(2),', ',rgbeps(3)
    WRITE(ufile,'(2A,1PE16.8,0P,2(A,I2))') xcomment,'colortemp=',colortemp,&
         '; flg_excludeeps=',flg_excludeeps,'; flg_scalceiling=',flg_scalceiling
    WRITE(ufile,'(A,A,F9.6,A,I2)') xcomment,'greencorr=',greencorr,'; flgx01=',flgx01
    WRITE(ufile,'(A,3(A,F9.6))') xcomment,'cctexp=',cctexp,'; cctexp2=',cctexp2,'; whtexp=',whtexp
    WRITE(ufile,'(A,3(A,F9.6))') xcomment,'rwhite=',whitergb(1),'; gwhite=',whitergb(2),'; bwhite=',whitergb(3)
    WRITE(ufile,'(A,3(A,F9.6))') xcomment,'rwhite2=',whitergb2(1),'; gwhite2=',whitergb2(2),'; bwhite2=',whitergb2(3)
    WRITE(ufile,'(4A)') xcomment,'file_cct="',trim(file_cct),'"'
!    READ(ufile,*) selrgb,selwluma,flg_maxrgb
!    READ(ufile,*) flgsplit,mirrormode,invertmode
!    READ(ufile,*) rgbperm
    RETURN
  END SUBROUTINE colorhelix_header
  
  SUBROUTINE rgbhelix_make(irange)
    IMPLICIT NONE
!    EXTERNAL fscurve
    REAL(KIND=8) :: xscurve
    INTEGER :: i,irange(0:1),urange(0:1)
    REAL(KIND=8) :: x,s,t,xt,cdev,rdev,gray,xamp,xrot,phi,amp,cphi,sphi,omega,omega2
    REAL(KIND=8) :: phi_start,sat2use,calphi,salphi,rellipse
    REAL(KIND=8),DIMENSION(1:3) :: rgb0,rgb,rgblin,xyz
    irange(0)=max(min(irange(0),nlevuse),0)
    irange(1)=max(min(irange(1),nlevuse),0)
    IF (irange(1)<irange(0)) THEN
       irange=(/0,nlevuse/)
       IF (firstmake) WRITE(*,'(A)') 'Using full level range'
    ELSE
       IF (firstmake) WRITE(*,'(2(A,I4.4))') 'Using levels from ',irange(0),' to ',irange(1)
    ENDIF
    firstmake=.FALSE.
    nlo(0:3)=0
    nhi(0:3)=0
    mindev(0:3)=0.d0
    maxdev(0:3)=0.d0
    IF (flgrgblike<0) THEN
!   Mimic Labhelix behaviour
!       phi_start=(1.d0-start_color)/4.d0
       phi_start=start_lab/4.d0
!       omega=rotations
    ELSE
!       phi_start=start_color/3.d0
       phi_start=start_rgb/3.d0
!       omega=rotations
    ENDIF
    phi_start=start_rgb/3.d0
    omega=rotations
    if (flgrots2>=1) then
       omega2=rots2
    else
       omega2=rotations
    endif
!    WRITE(*,*) 'RGBHELIX: flgrgblike,phi_start,omega =',flgrgblike,phi_start,omega
    CALL rgbhelix_basevectors
    IF (flg_inichroma==1) THEN
       urange=(/0,0/)
    ELSE
       urange=irange
    ENDIF
    DO i=urange(0),urange(1)
       IF (usesattable) THEN
          sat2use=afullsat(i)
       ELSE
          sat2use=sathue
       ENDIF
       IF (flg_inichroma==1) THEN
          x=x_ini
       ELSE IF (levelorder<0) THEN
          x=dble(urange(1)-i)/nlevuse
       ELSE
          x=dble(i)/nlevuse
       ENDIF
       !gray=x**pwr_gamma
       if (flgdouble/=0) then
          if (x<=xpartition) then
             t=xscal0*x
             xt=t
          else
             t=xscal1*(1.d0-x)
             xt=1.d0-t
          endif
       else
          t=x
          xt=x
       endif
       IF (pwr_gamma<0.d0) THEN
          xscurve=t**(-pwr_gamma)
          CALL scurve(xscurve,gray,sw_scurve,pwr_scurve)
!          print *,'pwr_gamma,x,xscurve,gray=',pwr_gamma,x,xscurve,gray
       ELSE
          CALL scurve(t,xscurve,sw_scurve,pwr_scurve)
          gray=xscurve**pwr_gamma
       ENDIF
       IF (flggrayrange>=1) THEN
          gray=grayrange(0)+(grayrange(1)-grayrange(0))*gray
       ENDIF
       xgry(i)=gray!for diagnostics only
       IF (flggamp>=1) THEN
          xamp=gray
       ELSE
          xamp=t**pwr_gamma_amp
       ENDIF
       IF (pwr_gamma_rot<0.d0) THEN
          xrot=xt**(-pwr_gamma_rot)
          CALL scurve(xrot,s,sw_srot,pwr_srot)
       ELSE
          CALL scurve(xt,xrot,sw_srot,pwr_srot)
          s=xrot**pwr_gamma_rot
       ENDIF
       if (x>xpartition.and.(flgdouble>=1.or.flgdouble<0)) then
          if (flgdouble==3) then
             phi=tau*(phi_start+omega2*s)+tau/2
          else if (flgdouble==2) then
             phi=tau*(phi_start+omega2*(1.d0-s))+tau/2
          else if (flgdouble==1) then
             phi=tau*(phi_start+omega2*s)
          else
             phi=tau*(phi_start+omega2*s*sgnphi)+tau*phi_double
          endif
       else
          phi=tau*(phi_start+omega*s)
       endif
       cphi=cos(phi)
       sphi=sin(phi)
       CALL colorhelix_deform(phi,rellipse)
       w(1:3)=(u(1:3)*cphi+v(1:3)*sphi)
       IF (itermode>=1.OR.flgmodel<0) THEN
          cdev=1
       ELSE IF (power_amp>0.d0) THEN!this is the default case
!          cdev=0.25d0*(4.d0*gray*(1.d0-gray))**power_amp
          cdev=0.25d0*(4.d0*xamp*(1.d0-xamp))**power_amp
       ELSE IF (power_amp<0.d0) THEN
          IF (xamp<0.5d0) THEN
             rdev=xamp
          ELSE
             rdev=1.d0-xamp
          ENDIF
          cdev=0.4*(2.5*rdev)**(-power_amp)
       ELSE
          cdev=1.d0
       ENDIF
       amp=sat2use*cdev*rellipse
!       print *,'phi,rellipse,amp =',phi*r2d,rellipse,amp
       red(i)=gray+amp*w(1)
       grn(i)=gray+amp*w(2)
       blu(i)=gray+amp*w(3)
!   some test output
       IF (verbose>=2) WRITE(44,'(I4,6(2X,F11.6))') i,phi*3.6d2/tau,w(1:3),amp
       rgb0(1)=red(i)
       rgb0(2)=grn(i)
       rgb0(3)=blu(i)
       IF (flgmodel<0) THEN!under construction!
          CALL mapto01(rgb0,rgb0,4,(/gray,sat2use/))
       ENDIF
       ! pre-define red,grn,blu for whitebalance
       red(i)=rgb0(1)
       grn(i)=rgb0(2)
       blu(i)=rgb0(3)
       CALL colorhelix_whitebalance(wbmode,i)
       rgb0=(/red(i),grn(i),blu(i)/)
       nlosave=nlo; nhisave=nhi
       isgamma=.TRUE.
       IF (t<1.d0-xmargin_noclip) THEN
          CALL palette_checkvalues(rgb0,rgb)
       ELSE
          rgb(:)=max(min(rgb0(:),rgb_ceiling(:)),0.d0)
       ENDIF
       nlo4info=nlo; nhi4info=nhi
       IF (i<lmin_maxsat.OR.i>lmax_maxsat) THEN!skip the check values outside testing range
          nlo=nlosave
          nhi=nhisave
       ENDIF
       red(i)=rgb(1)
       grn(i)=rgb(2)
       blu(i)=rgb(3)
       gry(i)=wr*red(i)+wg*grn(i)+wb*blu(i)!may differ from gray slightly
       IF (flg_inichroma==1) THEN
! direct mapping to 0:1
!          CALL mapto01(rgb,urgb_ini,31,(/0.d0,1.d0/))
!          CALL colorhelix_rgb_gamma(urgb_ini,rgblin,-1)
! map in linear RGB
          CALL colorhelix_rgb_gamma(rgb,rgb0,-1)
          CALL mapto01(rgb0,rgblin,31,(/0.d0,1.d0/))
          CALL colorhelix_rgb_gamma(rgblin,urgb_ini,1)
! Get XYZ
          CALL operate_matrix3x3(mat_rgb2xyz,rgblin,xyz)
          xyz_ini(:)=xyz(:)/sum(xyz)
       ENDIF
    ENDDO
    IF (verbose>=1) THEN
       WRITE(*,'(A,I4)') 'nlev =',nlevuse
       WRITE(*,'(A,4(1X,I4))') 'nlo tot,r,g,b =',nlo
       WRITE(*,'(A,4(1X,I4))') 'nhi tot,r,g,b =',nhi
!       WRITE(*,'(A,4(1X,F9.6))') 'min dev r,g,b,tot =',mindev(0:3)
!       WRITE(*,'(A,4(1X,F9.6))') 'max dev r,g,b,tot =',maxdev(0:3)
       WRITE(*,'(A,4(1X,F9.4,''%''))') 'min dev gray,r,g,b =',1.d2*mindev(0:3)
       WRITE(*,'(A,4(1X,F9.4,''%''))') 'max dev gray,r,g,b =',1.d2*maxdev(0:3)
    ENDIF
    RETURN
  END SUBROUTINE rgbhelix_make
  
  SUBROUTINE labhelix_make(irange)
    IMPLICIT NONE
!    EXTERNAL fscurve
    REAL(KIND=8) :: xscurve
    INTEGER :: i,j,irange(0:1),urange(0:1)
    REAL(KIND=8),DIMENSION(1:3) :: Lab,LCh,JCh,JChe,dum3,dum4,xyz,rgblin,rgb0,rgb
    REAL(KIND=8) :: x,s,t,xt,cdev,rdev,gray,xamp,xrot,phi,amp,cphi,sphi,omega,omega2
    REAL(KIND=8) :: phi_start,scalsat=100.d0,sat2use!,scalxyz=100.d0
    REAL(KIND=8) :: calphi,salphi,rellipse
    irange(0)=max(min(irange(0),nlevuse),0)
    irange(1)=max(min(irange(1),nlevuse),0)
    IF (irange(1)<irange(0)) THEN
       irange=(/0,nlevuse/)
       IF (firstmake) WRITE(*,'(A)') 'Using full level range'
    ELSE
       IF (firstmake) WRITE(*,'(2(A,I4.4))') 'Using levels from ',irange(0),' to ',irange(1)
    ENDIF
    firstmake=.FALSE.
    nlo(0:3)=0
    nhi(0:3)=0
    mindev(0:3)=0.d0
    maxdev(0:3)=0.d0
    IF (flgrgblike>0) THEN
!   Mimic RGBhelix behaviour
!       phi_start=0.25d0-start_color/3.d0
       phi_start=start_rgb/3.d0
       !omega=rotations
    ELSE
!       phi_start=start_color/4.d0
       phi_start=start_lab/4.d0
       !omega=rotations
    ENDIF
    phi_start=start_lab/4.d0
    omega=rotations
    if (flgrots2>=1) then
       omega2=rots2
    else
       omega2=rotations
    endif
    IF (flg_inichroma==1) THEN
       urange=(/0,0/)
    ELSE
       urange=irange
    ENDIF
!    WRITE(*,*) 'LABHELIX: flgrgblike,phi_start,omega =',flgrgblike,phi_start,omega
    DO i=urange(0),urange(1)
       IF (usesattable) THEN
          sat2use=afullsat(i)
       ELSE
          sat2use=sathue
       ENDIF
       IF (flg_inichroma==1) THEN
          x=x_ini
       ELSE IF (levelorder<0) THEN
          x=dble(urange(1)-i)/nlevuse
       ELSE
          x=dble(i)/nlevuse
       ENDIF
!       gray=x**pwr_gamma
       if (flgdouble/=0) then
          if (x<=xpartition) then
             t=xscal0*x
             xt=t
          else
             t=xscal1*(1.d0-x)
             xt=1.d0-t
          endif
       else
          t=x
          xt=x
       endif
       IF (pwr_gamma<0.d0) THEN
          xscurve=t**(-pwr_gamma)
          CALL scurve(xscurve,gray,sw_scurve,pwr_scurve)
       ELSE
          CALL scurve(t,xscurve,sw_scurve,pwr_scurve)
          gray=xscurve**pwr_gamma
       ENDIF
       IF (flggrayrange>=1) THEN
          gray=grayrange(0)+(grayrange(1)-grayrange(0))*gray
       ENDIF
       xgry(i)=gray!for diagnostics only
       IF (flggamp>=1) THEN
          xamp=gray
       ELSE
          xamp=t**pwr_gamma_amp
       ENDIF
       IF (pwr_gamma_rot<0.d0) THEN
          xrot=xt**(-pwr_gamma_rot)
          CALL scurve(xrot,s,sw_srot,pwr_srot)
       ELSE
          CALL scurve(xt,xrot,sw_srot,pwr_srot)
          s=xrot**pwr_gamma_rot
       ENDIF
!       s=x**pwr_gamma_rot
       if (x>xpartition.and.(flgdouble>=1.or.flgdouble<0)) then
          if (flgdouble==3) then
             phi=tau*(phi_start+omega2*s)+tau/2
          else if (flgdouble==2) then
             phi=tau*(phi_start+omega2*(1.d0-s))+tau/2
          else if (flgdouble==1) then
             phi=tau*(phi_start+omega2*s)
          else
             phi=tau*(phi_start+omega2*s*sgnphi)+tau*phi_double
          endif
       else
          phi=tau*(phi_start+omega*s)
       endif
       cphi=cos(phi)
       sphi=sin(phi)
       CALL colorhelix_deform(phi,rellipse)
       w(1:3)=(u(1:3)*cphi+v(1:3)*sphi)
!       cdev=0.25d0*(4.d0*gray*(1.d0-gray))**power_amp
       IF (itermode>=1) THEN
          cdev=1
       ELSE IF (power_amp>0.d0) THEN
          cdev=0.25d0*(4.d0*xamp*(1.d0-xamp))**power_amp
       ELSE IF (power_amp<0.d0) THEN
          IF (xamp<0.5d0) THEN
             rdev=xamp
          ELSE
             rdev=1.d0-xamp
          ENDIF
          cdev=0.4*(2.5*rdev)**(-power_amp)
       ELSE
          cdev=1.d0
       ENDIF
       amp=scalsat*sat2use*cdev*rellipse
!---- Store to Lab/LCh
       LCh(1)=100.d0*gray
       LCh(2)=amp
       IF (flgmodel==2) THEN
          LCh(3)=phi-0.18d0!DIN99d corrected for average angle shift (approx. to variable)
       ELSEIF (flgmodel==3) THEN
          LCh(3)=phi+0.000947d0!DIN99o corrected for average angle shift (constant)
       ELSEIF (flgmodel==4) THEN!NEW IPT color space
          LCh(3)=phi-0.106d0
       ELSEIF (flgmodel==5) THEN!NEW IPTEUC color space
          LCh(3)=phi-0.314d0
       ELSEIF (flgmodel>=6.AND.flgmodel<=8) THEN!CIECAM02 color space
          IF (flgmodel<=7) THEN
!             LCh(3)=phi-0.086d0!for JCh
             LCh(3)=phi-0.352d0!for JCHquad
!             LCh(3)=phi-0.d0!for JCh
          ELSE
             LCh(3)=phi-0.d0!for JCHquad
          ENDIF
       ELSE
          LCh(3)=phi
       ENDIF
       IF (LCh(3)<0.d0) THEN
          LCh(3)=LCh(3)+tau
       ELSE IF (LCh(3)>tau) THEN
          LCh(3)=LCh(3)-tau
       ENDIF
       CALL lab2lch(Lab,LCh,-1,0)
!       WRITE(*,'(A,I6,3(1X,F12.6))') 'i,Lgray,amp,phi =',i,1.d2*gray,amp,phi*57.29577951d0
!       WRITE(*,'(A,I6,3(1X,F12.6))') 'i,amp,sat2use =',i,amp,sat2use
       IF (flgmodel==1) THEN
          CALL lab2xyz(Lab,xyz,XYZwhite)
       ELSE IF (flgmodel==2) THEN
          CALL LCh99d2XYZ(LCh,XYZwhite,xyz,0)
       ELSE IF (flgmodel==3) THEN
          CALL LCh99o2Lab(LCh,Lab,0)
          CALL lab2xyz(Lab,xyz,XYZwhite)
       ELSE IF (flgmodel==4) THEN!NEW IPT color space
          CALL ipt2ich(Lab,LCh,11,-1)!here: LCh=ICh100 & Lab=IPT100,reverse direction
          IF (flg_maxrgb>=1) THEN
             dum3=(/Lab(2),Lab(3),Lab(1)/)
             CALL operate_matrix3x3(mat_ipt4corr,dum3,dum4)
             Lab=(/dum4(3),dum4(1),dum4(2)/)
          ENDIF
          CALL ipt2xyz(Lab,xyz,XYZwhite,1,1)!here:Lab=IPT100,whitecorr enabled (like always in Lab*)
       ELSE IF (flgmodel==5) THEN!NEW IPT color space
          CALL ipt2ich(Lab,LCh,11,-1)!here: LCh=ICh100 & Lab=IPT100,reverse direction
          IF (flg_maxrgb>=1) THEN
             dum3=(/Lab(2),Lab(3),Lab(1)/)
             CALL operate_matrix3x3(mat_ipt5corr,dum3,dum4)
             Lab=(/dum4(3),dum4(1),dum4(2)/)
          ENDIF
          CALL ipteuc2xyz(Lab,xyz,XYZwhite,1)!here:Lab=IPTE,whitecorr enabled (like always in Lab*)
       ELSE IF (flgmodel>=6.AND.flgmodel<=9) THEN!CAM02 color space
          IF (flgmodel==7.OR.flgmodel==9) THEN
             JChe=(/scal_jcheuc*LCh(1),LCh(2),LCh(3)/)
             CALL euc2ciecam(LCh,JChe,-1)
          ELSE
             dum3=(/scal_jch*LCh(1),LCh(2),LCh(3)/)
             LCh=dum3
          ENDIF
          IF (flgmodel<=7) THEN
             JCh=(/LCh(1),LCh(2),LCh(3)/); qmode=0
          ELSE
             JCh=(/LCh(1),LCh(2),r2g*LCh(3)/); qmode=1
          ENDIF
!          WRITE(*,*) '*********************************** C* =',LCh(2),'; C02 =',JCh(2)
!          WRITE(*,*) '*********************************** LCh =',LCh,'; JCh =',JCh
!          if (abs(x-0.419608d0)<0.00001d0) cf_verbose=2
!          cf_verbose=2
          CALL wrap_ciecam02(XYZ,JCh,dum3,qmode,10,-1)
!          cf_verbose=0
!          if (cf_verbose>=1) stop
       ENDIF
!          WRITE(*,*) '*********************************** C* =',LCh(2),'; amp =',amp
!       WRITE(*,*) '*********************************** LCh =',LCh,'; XYZ =',xyz
!       if (abs(x-1.d0)<0.0001d0) WRITE(*,*) '************XYZ =',xyz
!       if (abs(x-1.d0)<0.0001d0) WRITE(*,*) '************LCh =',LCh
       IF (i==0) THEN
          IF (sum(xyz)/=sum(xyz)) xyz(:)=0.d0!NaN handling
!          IF (xyz(1)/=xyz(1)) xyz(1)=0.d0!NaN handling
!          IF (xyz(2)/=xyz(2)) xyz(2)=0.d0!NaN handling
!          IF (xyz(3)/=xyz(3)) xyz(3)=0.d0!NaN handling
       ENDIF
       IF (flg_inichroma/=1) THEN
          CIELAB(:,i)=Lab(:)
          CIELCH(1,i)=Lch(1);CIELCH(2,i)=Lch(2);CIELCH(3,i)=Lch(3)*r2d!store as degrees
          CIEXYZ(:,i)=xyz
!          WRITE(*,'(A,4(1X,F9.6))') 'ciexyz =',xyz
       ENDIF
!       WRITE(*,*) 'i,amp,CIELAB(2,i),CIELAB(3,i) =',i,amp,CIELAB(2,i),CIELAB(3,i)
       CALL operate_matrix3x3(mat_xyz2rgb,xyz,rgb0)
       ! pre-define red,grn,blu for whitebalance
       CALL colorhelix_rgb_gamma(rgb0,rgb,1)
       red(i)=rgb(1)
       grn(i)=rgb(2)
       blu(i)=rgb(3)
       CALL colorhelix_whitebalance(wbmode,i)
       rgb0=(/red(i),grn(i),blu(i)/)
!       CALL colorhelix_rgb_gamma(rgb,rgb0,-1)
       nlosave=nlo; nhisave=nhi
       IF (i<nlevuse.and.t<1.d0-xmargin_noclip) THEN!Clipping due to XYZ whitepoint conversion unavoidable
!          isgamma=.FALSE.
          isgamma=.TRUE.
!          CALL palette_checkvalues(rgb0,rgblin)
          CALL palette_checkvalues(rgb0,rgb)
          nlo4info=nlo; nhi4info=nhi
          IF (i<lmin_maxsat.OR.i>lmax_maxsat) THEN!skip the check values outside testing range
             nlo=nlosave
             nhi=nhisave
          ENDIF
       ELSE
!          rgblin(:)=max(min(rgb0(:),rgblin_ceiling(:)),0.d0)
          rgb(:)=max(min(rgb0(:),rgb_ceiling(:)),0.d0)
       ENDIF
!       CALL colorhelix_rgb_gamma(rgblin,rgb,1)
       red(i)=rgb(1)
       grn(i)=rgb(2)
       blu(i)=rgb(3)
       gry(i)=wr*red(i)+wg*grn(i)+wb*blu(i)!may differ from gray slightly
       IF (i==0) THEN
          IF (red(i)/=red(i)) red(i)=0.d0!NaN handling
          IF (grn(i)/=grn(i)) grn(i)=0.d0
          IF (blu(i)/=blu(i)) blu(i)=0.d0
          IF (gry(i)/=gry(i)) gry(i)=0.d0
       ENDIF
       flags_palette(i)=0!default for 'nothing special'
!       print *,'red,grn,blu =',red(i),grn(i),blu(i)
       IF (red(i)/=red(i).OR.grn(i)/=grn(i).OR.blu(i)/=blu(i).OR.gry(i)/=gry(i)) THEN
          flags_palette(i)=-1!NaN
       ENDIF
       IF (flg_inichroma==1) THEN
          xyz_ini(:)=xyz(:)/sum(xyz)
          CALL mapto01(rgb,urgb_ini,31,(/0.d0,1.d0/))
!          WRITE(*,'(A,4(1X,F9.6))') 'xyz_ini =',xyz_ini
!          WRITE(*,'(A,4(1X,F9.6))') 'urgb_ini=',urgb_ini
!          stop
       ENDIF
       IF (verbose>=2.or.cf_verbose>=1) THEN
          write(*,2300) dble(i)/nlevuse,red(i),grn(i),blu(i)
          write(45,2300) (Lab(j),j=1,3),(xyz(j),j=1,3),(rgb(j),j=1,3),(rgblin(j),j=1,3)
!          write(45,2400) gray,(xyz(j)/sum(xyz),j=1,3),(rgb(j),j=1,3),(rgblin(j),j=1,3)
       ENDIF
    ENDDO
    IF (verbose>=1) THEN
       WRITE(*,'(A,I4)') 'nlev =',nlevuse
       WRITE(*,'(A,4(1X,I4))') 'nlo tot,r,g,b =',nlo
       WRITE(*,'(A,4(1X,I4))') 'nhi tot,r,g,b =',nhi
!       WRITE(*,'(A,4(1X,F9.6))') 'min dev r,g,b,tot =',mindev(0:3)
!       WRITE(*,'(A,4(1X,F9.6))') 'max dev r,g,b,tot =',maxdev(0:3)
       WRITE(*,'(A,4(1X,F9.4,''%''))') 'min dev gray,r,g,b =',1.d2*mindev(0:3)
       WRITE(*,'(A,4(1X,F9.4,''%''))') 'max dev gray,r,g,b =',1.d2*maxdev(0:3)
    ENDIF
  2200 FORMAT(3(F12.6,1X),9(1X,F12.6))
  2300 FORMAT(3(1PE12.4,1X),9(1X,1PE12.4))
  2400 FORMAT(F12.6,1X,9(1X,F12.6))
  2500 FORMAT(1PE12.4,1X,9(1X,1PE12.4))
    RETURN
  END SUBROUTINE labhelix_make

  SUBROUTINE gprgb_make(irange)
    IMPLICIT NONE
    INTEGER :: i,j,irange(0:1),urange(0:1)
    REAL(KIND=8) :: x
    REAL(KIND=8),DIMENSION(1:3) :: rgb0,rgb,rgblin,xyz
    irange(0)=max(min(irange(0),nlevuse),0)
    irange(1)=max(min(irange(1),nlevuse),0)
    IF (irange(1)<irange(0)) THEN
       irange=(/0,nlevuse/)
       IF (firstmake) WRITE(*,'(A)') 'Using full level range'
    ELSE
       IF (firstmake) WRITE(*,'(2(A,I4.4))') 'Using levels from ',irange(0),' to ',irange(1)
    ENDIF
    firstmake=.FALSE.
    IF (flg_inichroma==1) THEN
       urange=(/0,0/)
    ELSE
       urange=irange
    ENDIF
!    print *,'urange =',urange
    DO i=urange(0),urange(1)
       IF (flg_inichroma==1) THEN
          x=x_ini
       ELSE IF (levelorder<0) THEN
          x=dble(urange(1)-i)/nlevuse
       ELSE
          x=dble(i)/nlevuse
       ENDIF
!       print *,'i,x =',i,x
       CALL fnrgb(ifnrgb,x,rgb)
       red(i)=rgb(1)
       grn(i)=rgb(2)
       blu(i)=rgb(3)
       CALL colorhelix_whitebalance(wbmode,i)
!       rgb=(/red(i),grn(i),blu(i)/)
!       red(i)=rgb(1)
!       grn(i)=rgb(2)
!       blu(i)=rgb(3)
       gry(i)=wr*red(i)+wg*grn(i)+wb*blu(i)!may differ from gray slightly
       IF (i==0) THEN
          IF (red(i)/=red(i)) red(i)=0.d0!NaN handling
          IF (grn(i)/=grn(i)) grn(i)=0.d0
          IF (blu(i)/=blu(i)) blu(i)=0.d0
          IF (gry(i)/=gry(i)) gry(i)=0.d0
       ENDIF
       flags_palette(i)=0!default for 'nothing special'
!       print *,'red,grn,blu =',red(i),grn(i),blu(i)
       IF (red(i)/=red(i).OR.grn(i)/=grn(i).OR.blu(i)/=blu(i).OR.gry(i)/=gry(i)) THEN
          flags_palette(i)=-1!NaN
       ENDIF
       IF (flg_inichroma==1) THEN
! direct mapping to 0:1
!          CALL mapto01(rgb,urgb_ini,31,(/0.d0,1.d0/))
!          CALL colorhelix_rgb_gamma(urgb_ini,rgblin,-1)
! map in linear RGB
          CALL colorhelix_rgb_gamma(rgb,rgb0,-1)
          CALL mapto01(rgb0,rgblin,31,(/0.d0,1.d0/))
          CALL colorhelix_rgb_gamma(rgblin,urgb_ini,1)
! Get XYZ
          CALL operate_matrix3x3(mat_rgb2xyz,rgblin,xyz)
          xyz_ini(:)=xyz(:)/sum(xyz)
       ENDIF
    ENDDO
    RETURN
  END SUBROUTINE gprgb_make

  SUBROUTINE filergb_make(irange)
    IMPLICIT NONE
    INTEGER :: i,j,irange(0:1),urange(0:1),ndata
    INTEGER,PARAMETER :: ndatamax=100000
    REAL(KIND=8) :: x,t,r,g,b,xdatamin,xdatamax,cdatamax
    REAL(KIND=8),DIMENSION(0:3,0:ndatamax) :: rgbdata
    REAL(KIND=8),DIMENSION(1:3) :: rgb0,rgb,rgblin,xyz
    IF (firstmake) THEN
       OPEN(78,file=trim(palettefile))
       ndata=-1
       cdatamax=0.d0
       DO i=1,nheader
          READ(78,*)
       ENDDO
       DO i=0,nlevels_max
          IF (nheader<0) THEN
             CALL nextline(78)
          ENDIF
          READ(78,*,end=78,err=78) t,r,g,b
          IF (t>=userpalrange(0).and.t<=userpalrange(1).or.flguserrange<=0) THEN
             ndata=ndata+1
             rgbdata(0,ndata)=t
             rgbdata(1,ndata)=r
             rgbdata(2,ndata)=g
             rgbdata(3,ndata)=b
             cdatamax=max(cdatamax,rgbdata(1,ndata),rgbdata(2,ndata),rgbdata(3,ndata))
          ENDIF
       ENDDO
78     CLOSE(78)
       xdatamin=rgbdata(0,0)
       xdatamax=rgbdata(0,ndata)
!       print *,'>>>>>> xdatamin,xdatamax =',xdatamin,xdatamax,(rgbdata(0,0)-xdatamin)/(xdatamax-xdatamin)
       DO i=0,ndata
          rgbdata(0,i)=(rgbdata(0,i)-xdatamin)/(xdatamax-xdatamin)
          rgbdata(1,i)=rgbdata(1,i)/cdatamax
          rgbdata(2,i)=rgbdata(2,i)/cdatamax
          rgbdata(3,i)=rgbdata(3,i)/cdatamax
       ENDDO
    ENDIF
    irange(0)=max(min(irange(0),nlevuse),0)
    irange(1)=max(min(irange(1),nlevuse),0)
    IF (irange(1)<irange(0)) THEN
       irange=(/0,nlevuse/)
       IF (firstmake) WRITE(*,'(A)') 'Using full level range'
    ELSE
       IF (firstmake) WRITE(*,'(2(A,I4.4))') 'Using levels from ',irange(0),' to ',irange(1)
    ENDIF
    firstmake=.FALSE.
    IF (flg_inichroma==1) THEN
       urange=(/0,0/)
    ELSE
       urange=irange
    ENDIF
!    print *,'urange =',urange
    DO i=urange(0),urange(1)
       IF (flg_inichroma==1) THEN
          x=x_ini
       ELSE IF (levelorder<0) THEN
          x=dble(urange(1)-i)/nlevuse
       ELSE
          x=dble(i)/nlevuse
       ENDIF
!       print *,'i,x =',i,x
!       CALL fnrgb(ifnrgb,x,rgb)
       CALL rgblinint(ndata,rgbdata,1,x,rgb(1))
       CALL rgblinint(ndata,rgbdata,2,x,rgb(2))
       CALL rgblinint(ndata,rgbdata,3,x,rgb(3))
       red(i)=rgb(1)
       grn(i)=rgb(2)
       blu(i)=rgb(3)
       CALL colorhelix_whitebalance(wbmode,i)
!       rgb=(/red(i),grn(i),blu(i)/)
!       red(i)=rgb(1)
!       grn(i)=rgb(2)
!       blu(i)=rgb(3)
       gry(i)=wr*red(i)+wg*grn(i)+wb*blu(i)!may differ from gray slightly
       IF (i==0) THEN
          IF (red(i)/=red(i)) red(i)=0.d0!NaN handling
          IF (grn(i)/=grn(i)) grn(i)=0.d0
          IF (blu(i)/=blu(i)) blu(i)=0.d0
          IF (gry(i)/=gry(i)) gry(i)=0.d0
       ENDIF
       flags_palette(i)=0!default for 'nothing special'
!       print *,'red,grn,blu =',red(i),grn(i),blu(i)
       IF (red(i)/=red(i).OR.grn(i)/=grn(i).OR.blu(i)/=blu(i).OR.gry(i)/=gry(i)) THEN
          flags_palette(i)=-1!NaN
       ENDIF
       IF (flg_inichroma==1) THEN
! direct mapping to 0:1
!          CALL mapto01(rgb,urgb_ini,31,(/0.d0,1.d0/))
!          CALL colorhelix_rgb_gamma(urgb_ini,rgblin,-1)
! map in linear RGB
          CALL colorhelix_rgb_gamma(rgb,rgb0,-1)
          CALL mapto01(rgb0,rgblin,31,(/0.d0,1.d0/))
          CALL colorhelix_rgb_gamma(rgblin,urgb_ini,1)
! Get XYZ
          CALL operate_matrix3x3(mat_rgb2xyz,rgblin,xyz)
          xyz_ini(:)=xyz(:)/sum(xyz)
       ENDIF
    ENDDO
    RETURN
  END SUBROUTINE filergb_make

  SUBROUTINE colorhelix_deform(phi,kr)
    REAL(KIND=8) :: phi,kr,calphi,salphi
    IF (kellipse<=0.d0) THEN
       kr=1.d0
       RETURN
    ENDIF
    calphi=cos(phi+alpha)
    salphi=sin(phi+alpha)
    IF (flg_insect>=1) THEN
       kr=sqrt(calphi**2+(kellipse*salphi)**2)
    ELSE
       kr=kellipse/sqrt(salphi**2+(kellipse*calphi)**2)
    ENDIF
  END SUBROUTINE colorhelix_deform
  
  SUBROUTINE colorhelix_maxsat
!   Maximize saturation
    IMPLICIT NONE
    INTEGER :: iter,maxiter,maxii,ii,i,nbad,irange(0:1)
    INTEGER :: ilevel,lrange(0:1)
    REAL(KIND=8) :: s0,s1,ds,dsacc=1.d-15
    IF (flgmodel<0) THEN
       WRITE(*,*) 'COLORHELIX_MAXSAT: Not applicable'
       RETURN
    ENDIF
    maxiter=100; maxii=100
    usesattable=.FALSE.
    IF (doalloc_fullsat) THEN
       ALLOCATE (afullsat(0:nlevuse))
       doalloc_fullsat=.FALSE.
    ENDIF
    IF (itermode>=1) THEN
       lrange=(/0,nlevuse/)
    ELSE
       lrange=(/0,0/)
       irange=(/0,nlevuse/)
    ENDIF
    WRITE(*,*) 'maxsat: lrange =',lrange
    DO ilevel=lrange(0),lrange(1)
     IF (itermode>=1) THEN
        IF (ilevel==0.OR.ilevel==nlevuse) THEN
           maxsat=0.d0
           GOTO 10
        ENDIF
        irange=(/ilevel,ilevel/)
!        WRITE(*,*) 'maxsat: ilevel =',ilevel
     ENDIF
     s0=0.d0
     s1=maxxsat
     ds=1.d0
     iter=0
     DO iter=0,maxiter
       ii=-1
       nbad=0
       DO WHILE (nbad==0.AND.ii<=maxii)
          ii=ii+1
          sathue=s0+ii*ds
          CALL colorhelix_make(irange)
          nbad=nlo(0)+nhi(0)
!          write(*,*) ' inner: sat,nlo,nhi =',sathue,nlo,nhi,usesattable
!          write(*,*) ' inner: ii,sat,nbad =',ii,sathue,nbad
       ENDDO
       s1=sathue
       s0=s1-ds
!       write(*,*) 'iter,ii,s0,s1,ds =',iter,ii,s0,s1,ds
!       write(*,*) 'ilevel,s0,s1 =',ilevel,s0,s1
!       IF (itermode>=1) WRITE(*,*) 'maxsat: ilevel,iter =',ilevel,iter
       IF (ds<dsacc) EXIT
       ds=ds/2.d0
     ENDDO
!     maxsat=(s0+s1)/2.d0
     maxsat=s0!safer than half-interval
  10 IF (itermode>=1) afullsat(ilevel)=maxsat
!     IF (itermode>=1) WRITE(*,*) 'ilevel,fullsat =',ilevel,afullsat(ilevel)
    ENDDO
    WRITE(*,'(A,F14.8)') 'Maximum no-clipping saturation =',maxsat
    IF (itermode>=1) usesattable=.TRUE.
!    stop
     maxsat=max(maxsat,0.d0)
    RETURN
  END SUBROUTINE colorhelix_maxsat

  SUBROUTINE colorhelix_force_monotonic
!   Maximize saturation while monotonic
    IMPLICIT NONE
    INTEGER :: iter,maxiter,ii,i,nbad,irange(0:1)
    INTEGER :: ilevel,lrange(0:1)
    REAL(KIND=8) :: s0,s1,ds,dsacc=1.d-15
    maxiter=100
    usesattable=.FALSE.
    irange=(/0,nlevuse/)!clear modified ranges from colorhelix_maxsat
    write(*,*) 'irange =',irange
    s0=0.d0
    s1=maxxsat
    ds=1.d0
    iter=0
    DO iter=0,maxiter
       ii=-1
       iswellmonotonic=.TRUE.
       DO WHILE (iswellmonotonic)
          ii=ii+1
          sathue=s0+ii*ds
          CALL colorhelix_make(irange)
          CALL colorhelix_gray_slopes
!          write(*,*) ' inner: ii,sat,ismonotonic ,iswellmonotonic=',ii,sathue,ismonotonic,iswellmonotonic
       ENDDO
       s1=sathue
       s0=s1-ds
       IF (ds<dsacc) EXIT
       ds=ds/2.d0
     ENDDO
     maxsat=s0
     maxsat=max(maxsat,0.d0)
     RETURN
  END SUBROUTINE colorhelix_force_monotonic
  
  SUBROUTINE colorhelix_make(irange)
    IMPLICIT NONE
    INTEGER :: irange(0:1)
!    WRITE(*,*) 'COLHELIX: flgmodel =',flgmodel
    IF (flgmodel>=200) THEN
!       WRITE(*,*) 'FILERGB: flgmodel =',flgmodel
       CALL filergb_make(irange)
    ELSE IF (flgmodel>=100) THEN
!       WRITE(*,*) 'GPRGB: flgmodel =',flgmodel
       CALL gprgb_make(irange)
    ELSE IF (flgmodel>=1) THEN
!       WRITE(*,*) 'LABHELIX: flgmodel =',flgmodel
       CALL labhelix_make(irange)
    ELSE
!       WRITE(*,*) 'RGBHELIX: flgmodel =',flgmodel
       CALL rgbhelix_make(irange)
    ENDIF
!    stop!debug
    RETURN
  END SUBROUTINE colorhelix_make
  
  SUBROUTINE rgbhelix_basevectors
    IMPLICIT NONE
    REAL(KIND=8) u_norm,eps0,eps,rho_rg,wsum
    IF (wr<=0..OR.wg<=0..OR.wb<=0) THEN
!    IF (wr<=0..OR.wg<=0..OR.wb<=0.OR.wr**2+wg**2<=wb**2) THEN
       WRITE(*,*) 'Bad or incomplete weights input -- using defaults.'
!  .... Use defaults
       wr=0.30d0
       wg=0.59d0
       wb=0.11d0
    ENDIF
!  ---- First calculate V
    rho_rg=sqrt(wr**2+wg**2)
    v(1)=wg/rho_rg
    v(2)=-wr/rho_rg
    v(3)=0.D0
!  ---- Calculate U
    eps0=wb*wr/(wr**2+wg**2)
    u_norm=sqrt(1.d0+eps0**2+(wg/wr*eps0)**2)
    eps=eps0/u_norm
    u(1)=-eps
    u(2)=-eps*wg/wr
    u(3)=1.d0/u_norm
    IF (verbose>=1) THEN
       WRITE(*,'(A,3(1X,F9.6))') '|U0|=',u_norm
       WRITE(*,'(A,3(1X,F9.6))') 'U   =',u
       WRITE(*,'(A,3(1X,F9.6))') 'V   =',v
       WRITE(*,'(A,3(1X,F9.6))') 'W   =',wr,wg,wb
    ENDIF
    RETURN
  END SUBROUTINE rgbhelix_basevectors

! Proposed best-weights fit routine (for post-processing only)

  SUBROUTINE colorhelix_gray_error
    IMPLICIT NONE
    INTEGER :: i
    REAL(KIND=8) :: diff,sqdiff,sqsum,sqerr,stderr
    sqsum=0.d0
    DO i=0,nlevuse
       diff=gry(i)-xgry(i)
       IF (diff/=diff) diff=0.d0!NaN handling
       sqdiff=diff*diff
       sqsum=sqsum+sqdiff
!       WRITE(*,'(A,I8,4X,3(F16.8))') 'i,diff,sqdiff,sqsum =',i,diff,sqdiff,sqsum
    ENDDO
!    WRITE(*,'(A,3(F16.8))') 'diff,sqdiff,sqsum =',diff,sqdiff,sqsum
!---Calculate standard error
!   Use N=nlevuse+1 instead of N-1 since reference is given by gamma function,
!   not by sample average
    sqerr=sqsum/(nlevuse+1)
    stderr=sqrt(sqerr)
    WRITE(*,'(/A,F12.8/)') 'Gray standard error:',stderr
  END SUBROUTINE colorhelix_gray_error

  SUBROUTINE colorhelix_gray_slopes
!    USE palette_core!, ONLY : xgry,gry,slope_gry,mingryslope,maxgryslope, wr,wg,wb, nlevuse
    IMPLICIT NONE
    INTEGER :: i
    REAL(KIND=8) :: x,dx,dgdx,d2prev,d2next
    dx=1.d0/nlevuse
    ismonotonic=.TRUE.
    iswellmonotonic=.TRUE.
    mingryslope=1.d30;maxgryslope=-1.d30
    DO i=0,nlevuse
!    DO i=lmin_maxsat,lmax_maxsat
       x=dble(i)/nlevuse
       IF (i>0)       d2prev=gry(i)-gry(i-1)
       IF (i<nlevuse) d2next=gry(i+1)-gry(i)
       IF (i==0) THEN
          d2prev=1.d-15!tiny positive
          dgdx=d2next/dx
       ELSE IF (i==nlevuse) THEN
          d2next=1.d-15!tiny positive
       ENDIF
       IF (i>0) dgdx=d2prev/dx
       IF (i>=lmin_maxsat.and.i<=lmax_maxsat) THEN
          ismonotonic = ismonotonic .AND. sgnorder*d2prev>0.d0
          iswellmonotonic = iswellmonotonic .AND. sgnorder*(dgdx-minslope_thres)>0.d0
!       if (verbose>=1.AND.d2prev<=0.d0) write(*,*) 'i,d2prev,dgdx,gry =',i,d2prev,dgdx,gry(i)
          IF (dgdx>maxgryslope) THEN
             maxgryslope=dgdx
             imaxgryslope=i
          ENDIF
          IF (dgdx<mingryslope) THEN
             mingryslope=dgdx
             imingryslope=i
          ENDIF
       ENDIF
       slope_gry(i)=dgdx
       d2prev_gry(i)=d2prev
       d2next_gry(i)=d2next
    ENDDO
    RETURN
  END SUBROUTINE colorhelix_gray_slopes

  SUBROUTINE colorhelix_rgb_gamma(RGBin,RGBout,direction)
    IMPLICIT NONE
    INTEGER :: direction
    REAL(KIND=8),DIMENSION(3) :: RGBin,RGBout
    IF (rgb_gamma<-1.5d0) THEN!Assume urgb=pure mathematical srgb definition
       CALL mrgb_gamma(RGBin,RGBout,direction)
    ELSE IF (rgb_gamma<-0.5d0) THEN!Assume Rec. BT.709 if gamma is negative
       CALL rec709_gamma(RGBin,RGBout,direction)
    ELSE IF (rgb_gamma<0.01d0) THEN!Assume sRGB
!       WRITE(*,*) 'COLGAMMA: Using sRGB-gamma; input-g =',gamma
       CALL srgb_gamma(RGBin,RGBout,direction)
    ELSE
!       WRITE(*,*) 'COLGAMMA: Using power-law; input-g =',gamma
       CALL corr_gamma(RGBin,RGBout,rgb_gamma,direction)
    ENDIF
    RETURN
  END SUBROUTINE colorhelix_rgb_gamma

!  SUBROUTINE scurve(x,xscurve,sw,pwr)
!    IMPLICIT NONE
!    REAL(KIND=8) :: xscurve,x,sw,pwr
!    REAL(KIND=8) :: x05,xs,xw
!    x05=2.d0*(x-0.5d0)
!    xs=sign(abs(x05)**pwr,x05)
!    xw=sw*xs+(1.d0-sw)*x05
!    xscurve=(xw+1.d0)/2.d0
!    RETURN
!  END SUBROUTINE scurve
  
  SUBROUTINE scurve(x,xscurve,sw,pwr)
    IMPLICIT NONE
    REAL(KIND=8) :: xscurve,x,sw,pwr
    REAL(KIND=8) :: x05,xs,xw
    x05=2.d0*(x-0.5d0)
    IF (sw<0.d0.and.pwr>=0.d0) THEN
!       xs=sign((1.d0-abs(x05))**pwr,1.d0-x05)
       xs=(1.d0-abs(x05))**pwr
       IF (x<0.5d0) THEN
          xw=xs
       ELSE
          xw=2.d0-xs
       ENDIF
!       xw=-sw*xs+(1.d0+sw)*(1.d0-x05)
       xw=abs(sw)*xw+(1.d0-abs(sw))*2.d0*x
       xscurve=xw/2.d0
    ELSE
       xs=sign(abs(x05)**abs(pwr),x05)
       xw=sw*xs+(1.d0-sw)*x05
       xscurve=(xw+1.d0)/2.d0
    ENDIF
    RETURN
  END SUBROUTINE scurve

  SUBROUTINE ini_ciecam02
    IMPLICIT NONE
    INTEGER :: i
    REAL(KIND=8) :: yscal_bg,xyz_corr,dum1
    REAL(KIND=8),DIMENSION(3) :: XYZtest,dum3
    REAL(KIND=8),DIMENSION(3) :: JChtest=(/100.d0,0.d0,0.d0/),JCheuctest
    IF (did_ini_ciecam02) RETURN
!    flg_catmod=2
!    cdm2_illum=500.d0!*pi
!    surround_condition_select=1
!    IXYZ_background=XYZWHITE*20.d0
!    IXYZ_illuminant=XYZWHITE*100.d0
!    IXYZ_reference =XYZWHITE*100.d0
!    IXYZ_reference =(/100.d0,100.d0,100.d0/)!Equal energy as reference
    OPEN(70,FILE='colorhelix-ciecam02.par',STATUS='OLD')
    READ(70,*) surround_condition_select
    READ(70,*) cdm2_illum
    READ(70,*) yscal_bg
    READ(70,*) flg_catmod
    READ(70,*) IXYZ_illuminant
    READ(70,*) IXYZ_reference
    CLOSE(70)
    print *,'IXYZ_illuminant =',IXYZ_illuminant
    print *,'IXYZ_reference  =',IXYZ_reference
    print *,'IXYZ_background =',IXYZ_background
    IXYZ_background=1.d-2*max(min(yscal_bg,100.d0),0.d0)*IXYZ_illuminant
! Output for testrgbtable
    OPEN(71,FILE='colorhelix-ciecam02.aux')
    WRITE(71,7100) flg_catmod,surround_condition_select,cdm2_illum,&
         IXYZ_background,IXYZ_illuminant,IXYZ_reference
    CLOSE(71)
    XYZtest=IXYZ_illuminant
    CALL wrap_ciecam02(XYZtest,JChtest,dum3,qmode,1,-1)
    IF (flg_maxrgb==1) THEN
       xyz_corr=(minval(XYZtest(:)/IXYZ_illuminant(:)))**1.11d0
       XYZtest=IXYZ_illuminant/xyz_corr
       CALL wrap_ciecam02(XYZtest,JChtest,dum3,qmode,1,1)
    ENDIF
    CALL euc2ciecam(JChtest,JCheuctest,1)
    scal_jch=JChtest(1)/100.d0
    scal_jcheuc=JCheuctest(1)/100.d0
    did_ini_ciecam02=.TRUE.
    IF (verbose>=1) THEN
       WRITE(*,'(A,3(2X,F14.8))') 'XYZtest    =',XYZtest
       WRITE(*,'(A,3(2X,F14.8))') 'Jtest_ini  =',dum1
       WRITE(*,'(A,3(2X,F14.8))') 'JChtest    =',JChtest
       WRITE(*,'(A,3(2X,F14.8))') 'JCheuctest =',JCheuctest
       WRITE(*,'(A,3(2X,F14.8))') 'xyz_corr   =',xyz_corr
       WRITE(*,'(A,3(2X,F14.8))') 'scal_jch   =',scal_jch
       WRITE(*,'(A,3(2X,F14.8))') 'scal_jcheuc=',scal_jcheuc
    ENDIF
7100 FORMAT(5X,I2,2X,F6.3/F16.8,&
          3(/3(2X,F14.8)))
    RETURN
  END SUBROUTINE ini_ciecam02

!**** EXPERIMENTAL ****
  
  SUBROUTINE colorhelix_mirror
    implicit none
    integer,parameter :: nmax=65536,nmaxx=2*nmax
    integer :: i,ii,iw,iv,n,rp,gp,bp,mirroruse
    real(kind=8),dimension(0:3,1:nmax) :: wrgbi
    real(kind=8),dimension(0:3,1:nmaxx) :: wrgb
    logical :: mirroreven
    rp=rgbperm/100
    gp=(rgbperm-100*rp)/10
    bp=rgbperm-100*rp-10*gp
    mirroreven=2*int(mirrormode/2)==mirrormode
    if (mirroreven.and.invertmode<=0) then!mirror 2nd, invert none or both
       mirroruse=1
    else if (mirroreven.and.invertmode>0) then!mirror none, invert one side
       mirroruse=2
    else if (.not.mirroreven.and.invertmode<=0) then!mirror 1st, invert none or both
       mirroruse=3
    else if (.not.mirroreven.and.invertmode>0) then!mirror both, invert one side
       mirroruse=4
    endif
    print *,'rp,gp,bp =',rp,gp,bp
    do i=1,nlevuse+1
       wrgbi(1,i)=red(i-1)
       wrgbi(2,i)=grn(i-1)
       wrgbi(3,i)=blu(i-1)
    enddo
    do i=1,nlevuse+1
       if (mirroruse==1.or.mirroruse==2) then!first copy in original order
          ii=i
       else!first copy in reverse order
          ii=nlevuse-i+2
       endif
       iw=i
!       print *,'1: i,iw =',i,iw
       if ((invertmode==0).or.(invertmode==1.and.flgsplit>=1).or.invertmode>=2) then!first copy positive
          wrgb(1:3,iw)=wrgbi(1:3,ii)
       else!first copy negative
          wrgb(1:3,iw)=1.d0-wrgbi(1:3,ii)
       endif
    enddo
    if (flgsplit>=1) then
       do i=1,nlevuse+1
          if (mirroruse==1.or.mirroruse==4) then!second copy in reverse order
             ii=nlevuse-i+2
          else!second copy in original order
             ii=i
          endif
          iw=nlevuse+1+i
!       print *,'2: i,iw =',i,iw
          wrgb(1:3,nlevuse+1+i)=wrgbi(1:3,ii)
          if (invertmode<0.or.invertmode>=1) then!second copy negative
             wrgb(1:3,iw)=1.d0-wrgbi(1:3,ii)
          else!second copy positive
             wrgb(1:3,iw)=wrgbi(1:3,ii)
          endif
       enddo
    endif
    do i=1,nlevnoeps+1!rescale grey index
       wrgb(0,i)=dble(i-1)/(nlevnoeps)
    enddo
    do i=0,nlevnoeps
       if (flgsplit>=2.or.flgsplit<=0) then
          ii=i+1
       else
          if (i<=nlevuse) then
             ii=i+1
          else
             ii=i+2
          endif
       endif
       if (mirrormode>=2) then
          iv=nlevnoeps-i
       else
          iv=i
       endif
       gry(i)=wrgb(0,ii)
       red(iv)=wrgb(rp,ii)
       grn(iv)=wrgb(gp,ii)
       blu(iv)=wrgb(bp,ii)
!       write(20,120)  wrgb(0,i),wrgb(rp,i),wrgb(gp,i),wrgb(bp,i)
    enddo
120 format(f12.8,3(2x,f12.8))
    RETURN
  END SUBROUTINE colorhelix_mirror

  SUBROUTINE colorhelix_grayflat
    implicit none
    integer :: i
    real(kind=8),dimension(1:3) :: rgbflatuse,rgblin,wrgblin,rgbflatlin
    logical :: stopr=.false.,stopg=.false.,stopb=.false.
    if (flg_excludeeps>=1) then
       call colorhelix_rgb_gamma(whitergb,wrgblin,-1)
       call colorhelix_rgb_gamma(rgbflat,rgblin,-1)
       rgbflatlin(1:3)=rgblin(1:3)/max(wrgblin(1:3),1.d-3)
       call colorhelix_rgb_gamma(rgbflatlin,rgbflatuse,1)
    else
       rgbflatuse=rgbflat
    endif
    do i=0,nlevuse
       stopr=red(i)>=rgbflatuse(1).or.stopr
       stopg=grn(i)>=rgbflatuse(2).or.stopg
       stopb=blu(i)>=rgbflatuse(3).or.stopb
       if (.not.stopr) red(i)=max(red(i),rgbflatuse(1))
       if (.not.stopg) grn(i)=max(grn(i),rgbflatuse(2))
       if (.not.stopb) blu(i)=max(blu(i),rgbflatuse(3))
    enddo
    if (do_blackeps) then
       do i=nlevuse,0,-1
!          rgbw=(/red(i),grn(i),blu(i),gry(i)/)
          gry(i+2)=gry(i)
          red(i+2)=red(i)
          grn(i+2)=grn(i)
          blu(i+2)=blu(i)
       enddo
! continue dark gray for first eps slot
       gry(1)=-blackeps
       red(1)=red(2)
       grn(1)=grn(2)
       blu(1)=blu(2)
! switch to black for second eps slot (at the same gray position!)
       gry(0)=-blackeps
       red(0)=rgbeps(1)
       grn(0)=rgbeps(2)
       blu(0)=rgbeps(3)
    endif
    return
  END SUBROUTINE colorhelix_grayflat

  SUBROUTINE colorhelix_whitebalance(mode,icolor)
!Experimental color temperature shift for the RGB output
    integer :: i,icolor,icoluse,mode,flgreturn,nuse
    real(kind=8) :: xwhite,cctuse,swcct,swcct2,dum1
    real(kind=8),dimension(1:3) :: wrgb,wrgblin,wrgb2,wrgb2lin,rgb,rgblin,rgb0
    logical :: file_exists
    save wrgb,wrgblin,wrgb2,wrgb2lin,nuse
    flgreturn=0
    if (flgdouble/=0) then
       nuse=nlevuse/2
    else
       nuse=nlevuse
    endif
    if (mode==2) goto 12
    IF (.not.did_ini_cctramp) THEN
!       open(61,file='pd_colorramp.asc')
       inquire(file=trim(file_cct),exist=file_exists)
       if (.not.file_exists) then
          print *,'COLORHELIX error: CCT ramp file "',trim(file_cct),'" does not exist.'
          stop
       endif
       open(61,file=trim(file_cct))
       ncct=-1
       do i=0,nmaxcct
          read(61,*,end=9,err=9) cctramp(0:3,i)
!          if (i==0) cctmin=cctramp(0,i)
!          cctmax=cctramp(0,i)!update cctmax
          ncct=ncct+1
!          print *,'i,cctramp =',i,cctramp(0:3,i)
       enddo
       goto 9
9      close(61)
!       print *,'>>>> ncct =',ncct
       is_mired=cctramp(0,0)<500.d0!safe switching criterion
!       print *,'>>>> is_mired =',is_mired
       cctmin=cctramp(0,0)
       cctmax=cctramp(0,ncct)
       did_ini_cctramp=.true.
    ENDIF
    if (is_mired) then
       cctuse=1.d6/colortemp!convert kelvins to mireds
    else
       cctuse=colortemp!use kelvins
    endif
    IF (flgx01<=-1) THEN
       print '(a)','Whitepoint and bottom colour forced to neutral'
       flgreturn=1
       goto 11
    ELSE IF (cctuse<cctmin .or. cctuse>cctmax) THEN
       if (is_mired) then
          print '(a,f7.0,a,2(1pe12.4,a))','CCT =',cctuse,' outside ',cctmin,' and ',cctmax,' MK^-1'
       else
          print '(a,f7.0,a,2(1pe12.4,a))','CCT =',cctuse,' outside ',cctmin,' and ',cctmax,' K'
       endif
!       IF (minval(whitergb)<0.d0.and.flgx01>=1) THEN
       IF (wrgb1forcewhite) THEN
          print *,'Using D65 whitepoint'
!          whitergb=(/1.d0,1.d0,1.d0/) !already set to white here
          flgreturn=1
          goto 11
       ELSE
          print *,'Using manual whitepoint'
          goto 11
       ENDIF
    ENDIF
    call colorhelix_cctintp(cctuse)
!--- Apply white correction to full Colorhelix RGB table
11  wrgb=whitergb
    IF (wrgb2forcewhite) THEN
       print *,'Using neutral bottom colour'
!       whitergb2=(/1.d0,1.d0,1.d0/) !already set to white here
       flgreturn=1
    ENDIF
    wrgb2=whitergb2
    if (mode<=0) then
       if (flg_scalceiling>=1) then
          rgb_ceiling=(/1.d0,1.d0,1.d0/)
          rgblin_ceiling=(/1.d0,1.d0,1.d0/)
       else if (flg_scalceiling<0) then!bypass
          rgb_ceiling=(/1.d6,1.d6,1.d6/)
          rgblin_ceiling=(/1.d6,1.d6,1.d6/)
       else
          call colorhelix_rgb_gamma(wrgb,wrgblin,-1)
!          call colorhelix_rgb_gamma(wrgb2,wrgb2lin,-1)
          rgb_ceiling=wrgb
          rgblin_ceiling=wrgblin
       endif
       print *,'RGB ceiling     =',rgb_ceiling
       print *,'RGB ceiling,lin =',rgblin_ceiling
       RETURN
    endif
    call colorhelix_rgb_gamma(wrgb,wrgblin,-1)
    call colorhelix_rgb_gamma(wrgb2,wrgb2lin,-1)
    print *,'whitergb =',whitergb
    print *,'whitergb2=',whitergb2
    print *,'wrgb     =',wrgb
    print *,'wrgb2    =',wrgb2
    print *,'wrgblin  =',wrgblin
    print *,'wrgb2lin =',wrgb2lin
!    stop
    if (flgreturn==1) RETURN
    xwhite=wr*wrgb(1)+wg*wrgb(2)+wb*wrgb(3)
    print '(a,3(1x,f8.6),2x,f8.6)',   'whitergb, white =',whitergb,xwhite
    print '(a,3(1x,i3.3,5x),2x,i3.3)','in 255 units    =',nint(whitergb*255.d0),nint(xwhite*255.d0)
12  continue
    !print *,'wrgblin  =',wrgblin
    !print *,'wrgb2lin =',wrgb2lin
    if (icolor>nuse.and.flgdouble/=0) then
       icoluse=2*nuse-icolor
    else
       icoluse=icolor
    endif
    if (abs(cctexp)>1.d-12) then
       swcct=(dble(icoluse)/nuse)**abs(cctexp)
    else
       swcct=1.d0
    endif
    if (abs(cctexp2)>1.d-12) then
       if (cctexp2>0.d0) then
          swcct2=(dble(nuse-icoluse)/nuse)**cctexp2
       else
          swcct2=(dble(icoluse)/nuse)**abs(cctexp2)
       endif
    else
       swcct2=0.d0
    endif
    rgb=(/red(icolor),grn(icolor),blu(icolor)/)
    call colorhelix_rgb_gamma(rgb,rgblin,-1)
!       rgblin(:)=rgblin(:)*wrgblin(:)
!       rgblin(:)=rgblin(:)*(swcct*wrgblin(:)+(1.d0-swcct)*(/1.d0,1.d0,1.d0/))
!       print *,'w,w2 =',wrgblin,wrgb2lin
    if (cctexp>=0.d0) then
       rgblin(:)=rgblin(:)*(swcct*wrgblin(:)+(1.d0-swcct)*(/1.d0,1.d0,1.d0/))
    else
       if (abs(whtexp)<1.d-12) then
          dum1=1.d0
       else if (whtexp>0.d0) then
          dum1=(dble(icoluse)/nuse)**whtexp
       else
          dum1=1.d0-(dble(nuse-icoluse)/nuse)**abs(whtexp)
       endif
       rgblin(:)=rgblin(:)*((1.d0-dum1) * (swcct*wrgblin(:)&
            +(1.d0-swcct)*(/1.d0,1.d0,1.d0/)) + dum1*(/1.d0,1.d0,1.d0/))
    endif
    if (abs(cctexp2)>1.d-12) then
       rgblin(:)=rgblin(:)*(swcct2*wrgb2lin+(1.d0-swcct2)*(/1.d0,1.d0,1.d0/))
    endif
!    rgb0(:)=max(min(rgblin(:),1.d0),0.d0)
    rgb0=rgblin
    call colorhelix_rgb_gamma(rgb0,rgb,1)
    red(icolor)=rgb(1)
    grn(icolor)=rgb(2)
    blu(icolor)=rgb(3)
    gry(icolor)=wr*red(icolor)+wg*grn(icolor)+wb*blu(icolor)
    RETURN
  END SUBROUTINE colorhelix_whitebalance

  SUBROUTINE colorhelix_cctintp(cctuse)
    implicit none
    integer :: k,k0,k1
    real(kind=8) :: s,gctest,cctuse
    k0 = 0
    k1 = ncct
    do while (k1-k0>1)
       k = (k1+k0)/2
       if (cctuse<cctramp(0,k)) then
          k1 = k
       else
          k0 = k
       endif
!       print *,'**** k =',k
    enddo
    if (cctuse>=cctramp(0,k)) then
       k = k0-1
    else
       k = k0
    endif
!    print *,'**** k,k0 =',k,k0
    s=(cctuse-cctramp(0,k))/(cctramp(0,k+1)-cctramp(0,k))
    whitergb(1:3)=s*cctramp(1:3,k+1)+(1.d0-s)*cctramp(1:3,k)
    gctest=whitergb(2)*greencorr
    IF (gctest>1.d0) THEN
!       whitergb(1)=whitergb(1)/greencorr
!       whitergb(3)=whitergb(3)/greencorr
       whitergb(1)=whitergb(1)/gctest
       whitergb(3)=whitergb(3)/gctest
       whitergb(2)=1.d0
    ELSE
       whitergb(2)=whitergb(2)*greencorr
    ENDIF
    RETURN
  END SUBROUTINE colorhelix_cctintp

  SUBROUTINE fnrgb(trimode,x,rgb)
    implicit none
    integer trimode(3)
    real(kind=8) :: x,rgb(3),r,g,b
!    print *,'trimode=',trimode
    call thefunctions(trimode(1),x,r)
    call thefunctions(trimode(2),x,g)
    call thefunctions(trimode(3),x,b)
    rgb=(/r,g,b/)
!    print *,'x,rgb =',x,rgb
    return
  END SUBROUTINE fnrgb

  SUBROUTINE thefunctions(mode,x,f)
    implicit none
    integer :: mode,ifn
    real(kind=8) :: pi=3.14159265358979323846d0
    real(kind=8) :: x,f,lnm,lmin=400.d0,lmax=700.d0
    ifn=abs(mode)
    lnm=lmin+(lmax-lmin)*x
    if (ifn>=38.and.ifn<=40) rainbowsel=-1
    if (ifn>=41.and.ifn<=43) rainbowsel=0
    if (ifn>=44.and.ifn<=46) rainbowsel=1
    if (ifn>=47.and.ifn<=49) rainbowsel=2
    if (ifn>=54.and.ifn<=56) rainbowsel=3
    rbbrightsel=flgmodel-100
!    print *,'rainbowsel =',rainbowsel
    if (ifn==0) then
       f=0.d0
    else if (ifn==1) then
       f=0.5d0
    else if (ifn==2) then
       f=1.d0
    else if (ifn==3) then
       f=x
    else if (ifn==4) then
       f=x*x
    else if (ifn==5) then
       f=x**3
    else if (ifn==6) then
       f=x**4
    else if (ifn==7) then
       f=sqrt(x)
    else if (ifn==8) then
       f=sqrt(sqrt(x))
    else if (ifn==9) then
       f=sin(0.5d0*pi*x)
    else if (ifn==10) then
       f=cos(0.5d0*pi*x)
    else if (ifn==11) then
       f=abs(x-0.5d0)
    else if (ifn==12) then
       f=(2.d0*x-1.d0)**2
    else if (ifn==13) then
       f=sin(pi*x)
    else if (ifn==14) then
       f=abs(cos(pi*x))
    else if (ifn==15) then
       f=sin(2.d0*pi*x)
    else if (ifn==16) then
       f=cos(2.d0*pi*x)
    else if (ifn==17) then
       f=abs(sin(2.d0*pi*x))
    else if (ifn==18) then
       f=abs(cos(2.d0*pi*x))
    else if (ifn==19) then
       f=abs(sin(4.d0*pi*x))
    else if (ifn==20) then
       f=abs(cos(4.d0*pi*x))
    else if (ifn==21) then
       f=3.d0*x
    else if (ifn==22) then
       f=3.d0*x-1.d0
    else if (ifn==23) then
       f=3.d0*x-2.d0
    else if (ifn==24) then
       f=abs(3.d0*x-1.d0)
    else if (ifn==25) then
       f=abs(3.d0*x-2.d0)
    else if (ifn==26) then
       f=(3.d0*x-1.d0)/2.d0
    else if (ifn==27) then
       f=(3.d0*x-2.d0)/2.d0
    else if (ifn==28) then
       f=abs(3.d0*x-1.d0)/2.d0
    else if (ifn==29) then
       f=abs(3.d0*x-2.d0)/2.d0
    else if (ifn==30) then
       f=x/0.32d0-0.78125d0
    else if (ifn==31) then
       f=2.d0*x-0.84d0
    else if (ifn==32) then
       if (x<0.25d0) then
          f=4.d0*x
       else if (x<0.42d0) then
          f=1.d0
       else if(x<0.92d0) then
          f=-2.d0*x+1.84d0
       else
          f=x/0.08d0-11.5d0
       endif
    else if (ifn==33) then
       f=abs(2.d0*x-0.5d0)
    else if (ifn==34) then
       f=2.d0*x
    else if (ifn==35) then
       f=2.d0*x-0.5d0
    else if (ifn==36) then
       f=2.d0*x-1.d0
    else if (ifn==38.or.ifn==41.or.ifn==44.or.ifn==47.or.ifn==54) then
       call rgbrainbow1(lnm,1,f)
    else if (ifn==39.or.ifn==42.or.ifn==45.or.ifn==48.or.ifn==55) then
       call rgbrainbow1(lnm,2,f)
    else if (ifn==40.or.ifn==43.or.ifn==46.or.ifn==49.or.ifn==56) then
       call rgbrainbow1(lnm,3,f)
    else if (ifn==51) then
       call rgbrainbow2(lnm,1,f)
    else if (ifn==52) then
       call rgbrainbow2(lnm,2,f)
    else if (ifn==53) then
       call rgbrainbow2(lnm,3,f)
    else if (ifn==61) then
       call rgbrainbow3(lnm,1,f)
    else if (ifn==62) then
       call rgbrainbow3(lnm,2,f)
    else if (ifn==63) then
       call rgbrainbow3(lnm,3,f)
    else
       f=0.d0
    endif
    f=max(min(f,1.d0),0.d0)
    if (mode<0) f=1.d0-f
    return
  END SUBROUTINE thefunctions

  SUBROUTINE rgbrainbow1(lnm,sel,c)
! modified from http://stackoverflow.com/questions/3407942/rgb-values-of-visible-spectrum
! Credit for the original: Dan Bruton
    IMPLICIT NONE
    INTEGER :: sel
    REAL(KIND=8) :: lnm,c,r,g,b,lum,lummin=0.d0
    REAL(KIND=8) :: x0,x1,x2,x3,x4,x5,x6,x7
    REAL(KIND=8) :: r0,r1,r2,r3,r4,r5,r6,r7
    REAL(KIND=8) :: g0,g1,g2,g3,g4,g5,g6,g7
    REAL(KIND=8) :: b0,b1,b2,b3,b4,b5,b6,b7
    REAL(KIND=8) :: l0,l1,l2,l3
!    IF (rbbrightsel>=3) THEN
!       lummin=1.0d0
!    ELSE IF (rbbrightsel==2) THEN
!       lummin=0.6d0
!    ELSE IF (rbbrightsel==1) THEN
!       lummin=0.4d0
!    ELSE
!       lummin=0.2d0
!    ENDIF
    lummin=min(dble(rbbrightsel)/10.d0,1.d0)
    IF (rainbowsel==0) THEN!full-saturation rainbow
       x0=360.d0; x1=460.d0; x2=490.d0; x3=525.d0; x4=540.d0; x5=570.d0; x6=640.d0; x7=780.d0
       r0=0.70d0; r1=0.00d0; r2=0.00d0; r3=0.00d0; r4=0.00d0; r5=1.00d0; r6=1.00d0; r7=1.00d0
       g0=0.00d0; g1=0.00d0; g2=1.00d0; g3=1.00d0; g4=1.00d0; g5=1.00d0; g6=0.00d0; g7=0.00d0
       b0=1.00d0; b1=1.00d0; b2=1.00d0; b3=0.60d0; b4=0.00d0; b5=0.00d0; b6=0.00d0; b7=0.40d0
       l0=380.d0; l1=460.d0; l2=620.d0; l3=710.d0
    ELSE IF (rainbowsel==1) THEN!symmetric rainbow
       x0=360.d0; x1=450.d0; x2=500.d0; x3=525.d0; x4=550.d0; x5=600.d0; x6=650.d0; x7=780.d0
       r0=1.00d0; r1=0.00d0; r2=0.00d0; r3=0.00d0; r4=0.00d0; r5=1.00d0; r6=1.00d0; r7=1.00d0
       g0=0.00d0; g1=0.00d0; g2=1.00d0; g3=1.00d0; g4=1.00d0; g5=1.00d0; g6=0.00d0; g7=0.00d0
       b0=1.00d0; b1=1.00d0; b2=1.00d0; b3=0.50d0; b4=0.00d0; b5=0.00d0; b6=0.00d0; b7=1.00d0
       l0=400.d0; l1=450.d0; l2=650.d0; l3=700.d0
    ELSE IF (rainbowsel==2) THEN!more realistic fit
       x0=360.d0; x1=460.d0; x2=480.d0; x3=525.d0; x4=540.d0; x5=570.d0; x6=640.d0; x7=780.d0
       r0=0.50d0; r1=0.00d0; r2=0.00d0; r3=0.00d0; r4=0.00d0; r5=0.80d0; r6=1.00d0; r7=1.00d0
       g0=0.00d0; g1=0.00d0; g2=0.45d0; g3=0.90d0; g4=1.00d0; g5=0.80d0; g6=0.00d0; g7=0.00d0
       b0=0.70d0; b1=1.00d0; b2=0.80d0; b3=0.45d0; b4=0.00d0; b5=0.00d0; b6=0.00d0; b7=0.40d0
       l0=380.d0; l1=465.d0; l2=620.d0; l3=710.d0
    ELSE IF (rainbowsel==3) THEN!full color-wheel
       x0=400.d0; x1=450.d0; x2=500.d0; x3=525.d0; x4=550.d0; x5=600.d0; x6=650.d0; x7=700.d0
       r0=1.00d0; r1=0.00d0; r2=0.00d0; r3=0.00d0; r4=0.00d0; r5=1.00d0; r6=1.00d0; r7=1.00d0
       g0=0.00d0; g1=0.00d0; g2=1.00d0; g3=1.00d0; g4=1.00d0; g5=1.00d0; g6=0.00d0; g7=0.00d0
       b0=1.00d0; b1=1.00d0; b2=1.00d0; b3=0.50d0; b4=0.00d0; b5=0.00d0; b6=0.00d0; b7=1.00d0
       l0=400.d0; l1=450.d0; l2=650.d0; l3=700.d0
    ELSE!Close to the original version by Dan Bruton
       x0=380.d0; x1=440.d0; x2=490.d0; x3=500.d0; x4=510.d0; x5=580.d0; x6=645.d0; x7=780.d0
       r0=1.00d0; r1=0.00d0; r2=0.00d0; r3=0.00d0; r4=0.00d0; r5=1.00d0; r6=1.00d0; r7=1.00d0
       g0=0.00d0; g1=0.00d0; g2=1.00d0; g3=1.00d0; g4=1.00d0; g5=1.00d0; g6=0.00d0; g7=0.00d0
       b0=1.00d0; b1=1.00d0; b2=1.00d0; b3=0.50d0; b4=0.00d0; b5=0.00d0; b6=0.00d0; b7=0.00d0
       l0=380.d0; l1=450.d0; l2=640.d0; l3=730.d0
    ENDIF

    r=0.d0; g=0.d0; b=0.d0
    IF ((lnm.GE.x0).AND.(lnm.LE.x1)) THEN 
       IF (sel==1) r = r0+(r1-r0)*(lnm-x0)/(x1-x0)
       IF (sel==2) g = g0+(g1-g0)*(lnm-x0)/(x1-x0)
       IF (sel==3) b = b0+(b1-b0)*(lnm-x0)/(x1-x0)
!       print *,'r,g,b =',r,g,b
    ELSE IF ((lnm.GE.x1).AND.(lnm.LE.x2)) THEN
       IF (sel==1) r = r1+(r2-r1)*(lnm-x1)/(x2-x1)
       IF (sel==2) g = g1+(g2-g1)*(lnm-x1)/(x2-x1)
       IF (sel==3) b = b1+(b2-b1)*(lnm-x1)/(x2-x1)
    ELSE IF ((lnm.GE.x2).AND.(lnm.LE.x3)) THEN 
       IF (sel==1) r = r2+(r3-r2)*(lnm-x2)/(x3-x2)
       IF (sel==2) g = g2+(g3-g2)*(lnm-x2)/(x3-x2)
       IF (sel==3) b = b2+(b3-b2)*(lnm-x2)/(x3-x2)
    ELSE IF ((lnm.GE.x3).AND.(lnm.LE.x4)) THEN 
       IF (sel==1) r = r3+(r4-r3)*(lnm-x3)/(x4-x3)
       IF (sel==2) g = g3+(g4-g3)*(lnm-x3)/(x4-x3)
       IF (sel==3) b = b3+(b4-b3)*(lnm-x3)/(x4-x3)
    ELSE IF ((lnm.GE.x4).AND.(lnm.LE.x5)) THEN
       IF (sel==1) r = r4+(r5-r4)*(lnm-x4)/(x5-x4)
       IF (sel==2) g = g4+(g5-g4)*(lnm-x4)/(x5-x4)
       IF (sel==3) b = b4+(b5-b4)*(lnm-x4)/(x5-x4)
    ELSE IF ((lnm.GE.x5).AND.(lnm.LE.x6)) THEN
       IF (sel==1) r = r5+(r6-r5)*(lnm-x5)/(x6-x5)
       IF (sel==2) g = g5+(g6-g5)*(lnm-x5)/(x6-x5)
       IF (sel==3) b = b5+(b6-b5)*(lnm-x5)/(x6-x5)
    ELSE IF ((lnm.GE.x6).AND.(lnm.LE.x7)) THEN
       IF (sel==1) r = r6+(r7-r6)*(lnm-x6)/(x7-x6)
       IF (sel==2) g = g6+(g7-g6)*(lnm-x6)/(x7-x6)
       IF (sel==3) b = b6+(b7-b6)*(lnm-x6)/(x7-x6)
    ENDIF
    IF (lnm.GT.l2) THEN
       lum=lummin+(1.d0-lummin)*(l3-lnm)/(l3-l2)
    ELSE IF (lnm.LT.l1) THEN
       lum=lummin+(1.d0-lummin)*(lnm-l0)/(l1-l0)
    ELSE
       lum=1.d0
    ENDIF
    IF (sel==1) c=(r*lum)**(1.d0/gamma)
    IF (sel==2) c=(g*lum)**(1.d0/gamma)
    IF (sel==3) c=(b*lum)**(1.d0/gamma)
    RETURN
  END SUBROUTINE rgbrainbow1

  SUBROUTINE rgbrainbow2(lnm,sel,c)
! from http://stackoverflow.com/questions/3407942/rgb-values-of-visible-spectrum
    IMPLICIT NONE
    INTEGER :: sel
    REAL(KIND=8) :: lnm,c,r,g,b,lum,lummin=0.d0,l0,l1,l2,l3,t
    c=0.d0
    IF (sel==1) THEN
       IF (lnm>=400.d0.and.lnm<410.d0) THEN
          t=(lnm-400.d0)/(410.d0-400.d0)
          c=       0.33d0*t-0.20d0*t*t
       ELSE IF (lnm>=410.d0.and.lnm<475.d0) THEN
          t=(lnm-410.d0)/(475.d0-410.d0)
          c=0.14d0         -0.13d0*t*t
       ELSE IF (lnm>=545.d0.and.lnm<595.d0) THEN
          t=(lnm-545.d0)/(595.d0-545.d0)
          c=       1.98d0*t       -t*t
       ELSE IF (lnm>=595.d0.and.lnm<650.d0) THEN
          t=(lnm-595.d0)/(650.d0-595.d0)
          c=0.98d0+0.06d0*t-0.40d0*t*t
       ELSE IF (lnm>=650.d0.and.lnm<700.d0) THEN
          t=(lnm-650.d0)/(700.d0-650.d0)
          c=0.65d0-0.84d0*t+0.20d0*t*t
       ENDIF
    ELSE IF (sel==2) THEN
       IF (lnm>=415.d0.and.lnm<475.d0) THEN
          t=(lnm-415.d0)/(475.d0-415.d0)
          c=                0.80d0*t*t
       ELSE IF (lnm>=475.d0.and.lnm<590.d0) THEN
          t=(lnm-475.d0)/(590.d0-475.d0)
          c=0.80d0+0.76d0*t-0.80d0*t*t
       ELSE IF (lnm>=585.d0.and.lnm<639.d0) THEN!check if 585 or 590 nm
          t=(lnm-585.d0)/(639.d0-585.d0)
          c=0.84d0-0.84d0*t
       ENDIF
    ELSE IF (sel==3) THEN
       IF (lnm>=400.d0.and.lnm<475.d0) THEN
          t=(lnm-400.d0)/(475.d0-400.d0)
          c=       2.20d0*t-1.50d0*t*t
       ELSE IF (lnm>=475.d0.and.lnm<560.d0) THEN
          t=(lnm-475.d0)/(560.d0-475.d0)
          c=0.70d0       -t+0.30d0*t*t
       ENDIF
    ENDIF
    c=c**(1.d0/gamma)
    RETURN
  END SUBROUTINE rgbrainbow2

  SUBROUTINE rgbrainbow3(lnm,sel,c)
! Physically rendered visual spectrum approximation
    IMPLICIT NONE
    INTEGER :: i,sel,k,k0,k1,n
    REAL(KIND=8) :: lnm,c,u,d,s,lnmmin,lnmmax
    IF (.NOT.did_ini_rainbow) THEN
       OPEN(79,FILE='rainbow-400-700-chelix.asc')
       DO i=0,nlambda
          READ(79,*) rainbowdata(0:3,i)
       ENDDO
       CLOSE(79)
       did_ini_rainbow=.TRUE.
    ENDIF
    CALL rgblinint(nlambda,rainbowdata,sel,lnm,c)
    RETURN
  END SUBROUTINE rgbrainbow3

  SUBROUTINE rgblinint(ndata,rgbdata,sel,x,c)
    IMPLICIT NONE
    INTEGER :: ndata,sel,k0,k1,k
    REAL(KIND=8),DIMENSION(0:3,0:ndata) :: rgbdata
    REAL(KIND=8) :: x,c,u,d,s,xmin,xmax
    k0 = 0
    k1 = ndata
!      write(*,*) 'n,x =',n,x
!====== Bracketing
!---- Zero outside
    xmin=rgbdata(0,0)
    xmax=rgbdata(0,ndata)
!    print *,'LININT n,x,xmin,xmas =',n,x,xmin,xmax
    IF (x.lt.xmin.OR.x.gt.xmax) THEN
       c=0.d0
       RETURN
    ENDIF
!---- Search table
1   IF (k1-k0 .gt. 1) THEN
       k = (k1+k0)/2
       IF (rgbdata(0,k)>x) THEN
          k1 = k
       ELSE
          k0 = k
       ENDIF
       GOTO 1
    ENDIF
    k=k0
!====== Linear Interpolation
    u=(x-rgbdata(0,k0))
    d=(rgbdata(0,k1)-rgbdata(0,k0))!difference of x
    s=(rgbdata(sel,k1)-rgbdata(sel,k0))/d!slope = dy/dx = dc/dx
    c=u*s+rgbdata(sel,k0)
    c=c**(1.d0/gamma)
    RETURN
  END SUBROUTINE rgblinint
  
  SUBROUTINE nextline(iufile)
    CHARACTER(LEN=10) :: line
    INTEGER :: iufile,ufile,nskip,i
    LOGICAL :: verbose
    ufile=abs(iufile)
    verbose=iufile<0
    nskip=0
    eof_nextline=.false.
10  READ(ufile,'(a)',ERR=50,END=60) line
    !old      WRITE(first,'(a1)') line(1:1)
    DO i=1,100
       firstchar_nextline=line(i:i)
       IF (firstchar_nextline.ne. ' '.AND. firstchar_nextline.ne.char(0)) EXIT
    END DO
!      firstchar_nextline = line(1:1)
!      WRITE(*,'(5A)') 'line = "',line,'", firstchar_nextline = "',firstchar_nextline,'"'
    IF (firstchar_nextline.NE.'#' .AND. firstchar_nextline.NE.'C' .AND. firstchar_nextline.NE.'c' .AND. &
         firstchar_nextline.NE.';' .AND. firstchar_nextline.NE.'%' .AND. firstchar_nextline.NE.'!') THEN
       BACKSPACE ufile
       IF (verbose) THEN
          WRITE(*,*)
          WRITE(*,*) 'BACKSPACE: Skipped',nskip,' lines'
          WRITE(*,*)
       ENDIF
       RETURN
    ELSE
       nskip=nskip+1
       GOTO 10
    ENDIF

50  CONTINUE
    PRINT*,' nextline: error in reading line from unit ',ufile
!          ----
    STOP
60  CONTINUE
    eof_nextline=.true.
    PRINT*,' nextline: end of file (may be regular)'
    RETURN
  END SUBROUTINE nextline

END MODULE colorhelix_module
